#include "skinlib.h"
void __fastcall TControlSubClass::DrawRadioButton( int buttonState, int extra ) {
	int i, j, k;
	RECT textArea;

	if ( !SkinImage )
		return ;
	if ( !tradiobuttonPtr )
		return ;
	Graphics::TBitmap *localbkg = new Graphics::TBitmap();

	if ( SkinImage->Height != tradiobuttonPtr->Height )
		SkinImage->Height = tradiobuttonPtr->Height;
	if ( SkinImage->Width != tradiobuttonPtr->Width )
		SkinImage->Width = tradiobuttonPtr->Width;


	localbkg->Width = tradiobuttonPtr->Width ;
	localbkg->Height = tradiobuttonPtr->Height ;

	SkinImage->Canvas->Brush->Color = tradiobuttonPtr->Color ;
	SkinImage->Canvas->Brush->Style = bsSolid;
	SkinImage->Canvas->FillRect(Rect(0,0,tradiobuttonPtr->Width ,tradiobuttonPtr->Height));


	if( buttonState==0 && !mmove)
	  SkinImage->Canvas->Draw(0,( tradiobuttonPtr->Height / 2 ) - 8,myShare->MainGE->GetSubImage(0,0,myShare->MainGE->bmpArray[2]->Width/3,myShare->MainGE->bmpArray[2]->Height,myShare->MainGE->bmpArray[2],bmpBuffer));
	else if( buttonState==1 )
	  SkinImage->Canvas->Draw(0,( tradiobuttonPtr->Height / 2 ) - 8,myShare->MainGE->GetSubImage(2,0,myShare->MainGE->bmpArray[2]->Width/3,myShare->MainGE->bmpArray[2]->Height,myShare->MainGE->bmpArray[2],bmpBuffer));
	else if( mmove )
	  SkinImage->Canvas->Draw(0,( tradiobuttonPtr->Height / 2 ) - 8,myShare->MainGE->GetSubImage(1,0,myShare->MainGE->bmpArray[2]->Width/3,myShare->MainGE->bmpArray[2]->Height,myShare->MainGE->bmpArray[2],bmpBuffer));

	// output Text
	textArea.left = myShare->MainGE->bmpArray[2]->Width/3 +5;
	textArea.top = ( tradiobuttonPtr->Height - SkinImage->Canvas->TextHeight( tradiobuttonPtr->Caption ) ) / 2;
	textArea.right = textArea.left + SkinImage->Canvas->TextWidth( tradiobuttonPtr->Caption );
	textArea.bottom = textArea.top + SkinImage->Canvas->TextHeight( tradiobuttonPtr->Caption );
	if ( mmove )
		SkinImage->Canvas->Font->Color = clBlue;
	else
		SkinImage->Canvas->Font->Color = clBlack;
	DrawText( SkinImage->Canvas->Handle , tradiobuttonPtr->Caption.c_str() , tradiobuttonPtr->Caption.Length() , &textArea , DT_TABSTOP );

	if ( tradiobuttonPtr->Enabled == false )
		skinAlpha( SkinImage , localbkg , 150 );

	HDC dc;
	dc = GetDC( tradiobuttonPtr->Handle );
	BitBlt( dc, 0, 0, tradiobuttonPtr->Width, tradiobuttonPtr->Height, SkinImage->Canvas->Handle, 0, 0, SRCCOPY );
	ReleaseDC( tradiobuttonPtr->Handle , dc );
	delete localbkg;


}



void __fastcall TControlSubClass::TRadioButtonMsg( unsigned int Msg ) {
	switch ( Msg ) {
		case WM_MOUSEMOVE:
			if ( ! tradiobuttonPtr->Checked )
				DrawRadioButton( 0, 0 );
			else
				DrawRadioButton( 1, 0 );
			mmove = true;

			break;
		case WM_LBUTTONDOWN:
			if ( ! tradiobuttonPtr->Checked )
				DrawRadioButton( 0, 0 );
			else
				DrawRadioButton( 1, 0 );
			mdown = true;
			break;
		case WM_LBUTTONUP:
			if ( ! tradiobuttonPtr->Checked )
				DrawRadioButton( 0, 0 );
			else
				DrawRadioButton( 1, 0 );
			mdown = false;
			break;
		case WM_KEYDOWN:
			if ( ! tradiobuttonPtr->Checked )
				DrawRadioButton( 0, 0 );
			else
				DrawRadioButton( 1, 0 );
			mdown = true;
			break;
		case WM_KEYUP:
			if ( ! tradiobuttonPtr->Checked )
				DrawRadioButton( 0, 0 );
			else
				DrawRadioButton( 1, 0 );
			mdown = false;
			break;
		case CM_MOUSELEAVE:
			mmove = false;
			mdown = false;
			if ( ! tradiobuttonPtr->Checked )
				DrawRadioButton( 0, 0 );
			else
				DrawRadioButton( 1, 0 );
			break;
		case WM_PAINT:
			if ( ! tradiobuttonPtr->Checked )
				DrawRadioButton( 0, 0 );
			else
				DrawRadioButton( 1, 0 );
			break;
		case CM_MOUSEENTER:
			mmove = true;
			if ( ! tradiobuttonPtr->Checked )
				DrawRadioButton( 0, 0 );
			else
				DrawRadioButton( 1, 0 );
			break;
		case WM_LBUTTONDBLCLK:
			if ( ! tradiobuttonPtr->Checked )
				DrawRadioButton( 0, 0 );
			else
				DrawRadioButton( 1, 0 );
			break;
		case WM_ERASEBKGND:
			if ( ! tradiobuttonPtr->Checked )
				DrawRadioButton( 0, 0 );
			else
				DrawRadioButton( 1, 0 );
			break;
		case WM_NCPAINT:
			if ( ! tradiobuttonPtr->Checked )
				DrawRadioButton( 0, 0 );
			else
				DrawRadioButton( 1, 0 );
			break;
		case WM_SETFOCUS:
			//ݭne@focus rect
			if ( ! tradiobuttonPtr->Checked )
				DrawRadioButton( 0, 0 );
			else
				DrawRadioButton( 1, 0 );
			break;
		default:
			if ( ! tradiobuttonPtr->Checked )
				DrawRadioButton( 0, 0 );
			else
				DrawRadioButton( 1, 0 );
			break;
	}
}
