/*
NatureSkin (V0.9) 2006 OpenSource Edition

Author: Liu,Jiun Jiue. In Taiwan NCTU 

Copyright (c) 2006  Liu,Jiun Jiue.

GPL License

Homepage: http://www.cs.nctu.edu.tw/~hank1985/opensource/natureskin/

*/
#ifndef SkinCpp
#define SkinCpp
#include "SkinLib.h"


//#include "TNaturePanel.cpp"
#include "NGlobal.cpp"
#include "NaGe.cpp"
#include "NControlSubClass.cpp"
#include "NComboBox.cpp"
#include "NButton.cpp"
#include "NScrollBar.cpp"
#include "NCheckBox.cpp"
#include "NColorBox.cpp"
#include "NRadioButton.cpp"
#include "NPanel.cpp"
#include "NBitBtn.cpp"
#include "NPageControl.cpp"
#include "NMemo.cpp"
#include "NStringGrid.cpp"
#include "NListBox.cpp"
#include "NTreeView.cpp"
#include "NListView.cpp"
#include "NCheckListBox.cpp"
#include "NDrawGrid.cpp"
#include "NRadioGroup.cpp"
#include "NGroupBox.cpp"
#include "NMyScrollBar.cpp" 
//--------------------------------------------
NatureSkin::NatureSkin( TForm *Owner ) {
	int i;

//	ThemeFileName = _ThemeFileName ;

	for ( i = 0;i < MaxControlSkinAmount ;i++ )
		myControl[ i ] = NULL;
	controlCount = 0;
	myForm = Owner; 
	isActived = false;

	naGE = new NatureGraphicEngine;
	myShare = new NShareObject;
	myShare->MainCore = this;
	myShare->MainGE = naGE;


//	void * inst;
//	inst = ::LoadLibrary(ThemeFileName.c_str());
	memset(&ThemeSetting,0,sizeof(ThemeSetting));
	ThemeSetting.GlassStyle = true;
	ThemeSetting.SkinTForm = true;
	ThemeSetting.SkinBackground = true;
	ThemeSetting.SkinTToolBar = true;
	ThemeSetting.SkinTButton = true;
	ThemeSetting.SkinTBitBtn = true;
	ThemeSetting.SkinTScrollBar = true;
	ThemeSetting.SkinTPanel = true;
	ThemeSetting.SkinTRadioButton = true;
	ThemeSetting.SkinTCheckBox = true;
//	ThemeSetting.SkinTRadioGroup = true;
//	ThemeSetting.SkinTGroupBox = true;
	ThemeSetting.SkinTListBox = true;
	ThemeSetting.SkinTMemo = true;
	ThemeSetting.SkinTListBox = true;
	ThemeSetting.SkinTListView = true;
	ThemeSetting.SkinTTreeView = true;
	ThemeSetting.SkinTCheckListBox = true;
	ThemeSetting.SkinTStringGrid = true;
	ThemeSetting.SkinTDrawGrid = true;
	ThemeSetting.SkinTPageControl = true;
	ThemeSetting.SkinTComboBox = true;
	ThemeSetting.SkinTColorBox = true;				

//	::FreeLibrary( inst );

}
NatureSkin::~NatureSkin() {

	if ( isActived ) {
		Inactive();	}

	if( myShare!=NULL )
		delete myShare;
	if( naGE!=NULL )
    	delete naGE;

}
void __fastcall NatureSkin::FreeControls() {
	int i;
	// HUȮɤ
	//RPageControl SubClass , ]Ḽ٦]tBitBtn
	/*        for ( i = 0;i < controlCount;i++ ){
					if( myControl[i]->ControlType == "TBitBtn" || myControl[i]->ControlType == "TButton"  ){
	                        delete myControl[ i ];
	                        myControl[ i ]=NULL;
	                }
	        }*/
	for ( i = 0;i < controlCount;i++ )
		if ( myControl[ i ] != NULL ) {
			delete myControl[ i ];
			myControl[ i ] = NULL;
		}
}

void __fastcall NatureSkin::Inactive() {
	if ( isActived == false )
		return ;
	int i;

	isActived = false;
	for ( i = 0;i < controlCount;i++ ) {
		myControl[ i ] ->freeze = true ;
	}
	for ( i = 0;i < controlCount;i++ ) {
		if ( myControl[ i ] ->ControlType == "TButton" ) {
			if ( myControl[ i ] ->tbuttonPtr == NULL )
				continue;
			myControl[ i ] ->RestoreWProc( myControl[ i ] ->tbuttonPtr->WindowProc );
			myControl[ i ] ->tbuttonPtr->Repaint() ;
		} else if ( myControl[ i ] ->ControlType == "TBitBtn" ) {
			if ( myControl[ i ] ->tbitbtnPtr == NULL )
				continue;
			myControl[ i ] ->RestoreWProc( myControl[ i ] ->tbitbtnPtr->WindowProc );
			myControl[ i ] ->tbitbtnPtr->Repaint() ;
		} else if ( myControl[ i ] ->ControlType == "TRadioButton" ) {
			if ( myControl[ i ] ->tradiobuttonPtr == NULL )
				continue;
			myControl[ i ] ->RestoreWProc( myControl[ i ] ->tradiobuttonPtr->WindowProc );
			myControl[ i ] ->tradiobuttonPtr->Repaint() ;
		} else if ( myControl[ i ] ->ControlType == "TCheckBox" ) {
			if ( myControl[ i ] ->tcheckboxPtr == NULL )
				continue;
			myControl[ i ] ->RestoreWProc( myControl[ i ] ->tcheckboxPtr->WindowProc );
			myControl[ i ] ->tcheckboxPtr->Repaint() ;
		} else if ( myControl[ i ] ->ControlType == "TScrollBar" ) {
			if ( myControl[ i ] ->tscrollbarPtr == NULL )
				continue;
			myControl[ i ] ->RestoreWProc( myControl[ i ] ->tscrollbarPtr->WindowProc );
			myControl[ i ] ->tscrollbarPtr->Repaint() ;
		} else if ( myControl[ i ] ->ControlType == "TComboBox" ) {
			if ( myControl[ i ] ->tcomboboxPtr == NULL )
				continue;
			myControl[ i ] ->RestoreWProc( myControl[ i ] ->tcomboboxPtr->WindowProc );
			myControl[ i ] ->tcomboboxPtr->Repaint() ;
		} else if ( myControl[ i ] ->ControlType == "TColorBox" ) {
			if ( myControl[ i ] ->tcolorboxPtr == NULL )
				continue;
			myControl[ i ] ->RestoreWProc( myControl[ i ] ->tcolorboxPtr->WindowProc );
			myControl[ i ] ->tcolorboxPtr->Repaint() ;
		} else if ( myControl[ i ] ->ControlType == "TPanel" ) {
			if ( myControl[ i ] ->tpanelPtr == NULL )
				continue;
			myControl[ i ] ->RestoreWProc( myControl[ i ] ->tpanelPtr->WindowProc );
			myControl[ i ] ->tpanelPtr->Repaint() ;
		} else if ( myControl[ i ] ->ControlType == "TGroupBox" ) {
			if ( myControl[ i ] ->tgroupboxPtr == NULL )
				continue;
			myControl[ i ] ->RestoreWProc( myControl[ i ] ->tgroupboxPtr->WindowProc );
			myControl[ i ] ->tgroupboxPtr->Repaint() ;
		} else if ( myControl[ i ] ->ControlType == "TMemo" ) {
			if ( myControl[ i ] ->tmemoPtr == NULL )
				continue;
			myControl[ i ] ->RestoreWProc( myControl[ i ] ->tmemoPtr->WindowProc );
			myControl[ i ] ->tmemoPtr->Repaint() ;
		} else if ( myControl[ i ] ->ControlType == "TDrawGrid" ) {
			if ( myControl[ i ] ->tdrawgridPtr == NULL )
				continue;
			myControl[ i ] ->RestoreWProc( myControl[ i ] ->tdrawgridPtr->WindowProc );
			myControl[ i ] ->tdrawgridPtr->Repaint() ;
		} else if ( myControl[ i ] ->ControlType == "TListBox" ) {
			if ( myControl[ i ] ->tlistboxPtr == NULL )
				continue;
			myControl[ i ] ->RestoreWProc( myControl[ i ] ->tlistboxPtr->WindowProc );
			myControl[ i ] ->tlistboxPtr->Repaint() ;
		} else if ( myControl[ i ] ->ControlType == "TTreeView" ) {
			if ( myControl[ i ] ->ttreeviewPtr == NULL )
				continue;
			myControl[ i ] ->RestoreWProc( myControl[ i ] ->ttreeviewPtr->WindowProc );
			myControl[ i ] ->ttreeviewPtr->Repaint() ;
		} else if ( myControl[ i ] ->ControlType == "TListView" ) {
			if ( myControl[ i ] ->tlistviewPtr == NULL )
				continue;
			myControl[ i ] ->RestoreWProc( myControl[ i ] ->tlistviewPtr->WindowProc );
			myControl[ i ] ->tlistviewPtr->Repaint() ;
		} else if ( myControl[ i ] ->ControlType == "TCheckListBox" ) {
			if ( myControl[ i ] ->tchecklistboxPtr == NULL )
				continue;
			myControl[ i ] ->RestoreWProc( myControl[ i ] ->tchecklistboxPtr->WindowProc );
			myControl[ i ] ->tchecklistboxPtr->Repaint() ;
		} else if ( myControl[ i ] ->ControlType == "TRadioGroup" ) {
			if ( myControl[ i ] ->tradiogroupPtr == NULL )
				continue;
			myControl[ i ] ->RestoreWProc( myControl[ i ] ->tradiogroupPtr->WindowProc );
			myControl[ i ] ->tradiogroupPtr->Repaint() ;
		} else if ( myControl[ i ] ->ControlType == "TStringGrid" ) {
			if ( myControl[ i ] ->tstringgridPtr == NULL )
				continue;
			myControl[ i ] ->RestoreWProc( myControl[ i ] ->tstringgridPtr->WindowProc );
			myControl[ i ] ->tstringgridPtr->Repaint() ;
		} else if ( myControl[ i ] ->ControlType == "TPageControl" ) {
			if ( myControl[ i ] ->tpagecontrolPtr == NULL )
				continue;
			//                         ;
			myControl[ i ] ->RestoreWProc( myControl[ i ] ->tpagecontrolPtr->WindowProc );
			myControl[ i ] ->tpagecontrolPtr->OwnerDraw = false;
			myControl[ i ] ->tpagecontrolPtr->OnDrawTab = NULL ;

		}
	}
	//
	for ( i = 0;i < controlCount;i++ ) {
		if ( myControl[ i ] ->nscrollbar != NULL )
			delete myControl[ i ] ->nscrollbar;
		if ( myControl[ i ] ->nscrollbar2 != NULL )
			delete myControl[ i ] ->nscrollbar2;
		myControl[ i ] ->nscrollbar = NULL;
		myControl[ i ] ->nscrollbar2 = NULL;

	}




	FreeControls();
	controlCount = 0;
}
bool __fastcall NatureSkin::AlreadySkin( unsigned int _Handle ) {
//	return false;
	int i;
	for ( i = 0;i < controlCount;i++ ) {
		if ( ( ( unsigned int ) myControl[ i ] ->myHandle ) == ( ( unsigned int ) _Handle ) ) {
//			ShowMessage( "@@" );
			return true;
		}
	}
	return false;
}
bool __fastcall NatureSkin::SkinControls() {
	int i;
	// PageControl nSkin ( _h|oͷsͪlSQSkin )
	for ( i = 0;i < myForm->ComponentCount ;i++ ) {
		if ( ThemeSetting.SkinTPageControl && String( myForm->Components[ i ] ->ClassName() ) == "TPageControl" ) {
			TPageControl * tpagecontrolPtr;
			tpagecontrolPtr = ( TPageControl * ) myForm->Components[ i ] ;
			if ( !AlreadySkin( ( unsigned int ) tpagecontrolPtr->Handle ) ) {
				myControl[ controlCount ] = new TControlSubClass( myForm );
				myControl[ controlCount ] ->ControlType = "TPageControl" ;
				myControl[ controlCount ] ->tpagecontrolPtr = tpagecontrolPtr;
				myControl[ controlCount ] ->myShare = myShare;
				myControl[ controlCount ] ->initCanvas() ;
				myControl[ controlCount ] ->myHandle = ( unsigned int ) tpagecontrolPtr->Handle;
				tpagecontrolPtr->OnDrawTab = myControl[ controlCount ] ->PageControlDrawTab ;
				tpagecontrolPtr->OwnerDraw = true ;
				myControl[ controlCount ] ->ReplaceWProc( tpagecontrolPtr->WindowProc );
				tpagecontrolPtr->DoubleBuffered = true;
				controlCount++;
			}
		}
	}
	//
	for ( i = 0;i < myForm->ComponentCount ;i++ ) {
		if ( ThemeSetting.SkinTButton && String( myForm->Components[ i ] ->ClassName() ) == "TButton" ) {
			TButton * tbuttonPtr;
			tbuttonPtr = ( TButton * ) myForm->Components[ i ] ;
			if ( !AlreadySkin( ( unsigned int ) tbuttonPtr->Handle ) ) {
				myControl[ controlCount ] = new TControlSubClass( myForm );
				myControl[ controlCount ] ->ControlType = "TButton" ;
				myControl[ controlCount ] ->tbuttonPtr = tbuttonPtr;
				myControl[ controlCount ] ->myShare = myShare;
				myControl[ controlCount ] ->initCanvas() ;
				myControl[ controlCount ] ->ReplaceWProc( tbuttonPtr->WindowProc );
				myControl[ controlCount ] ->myHandle = ( unsigned int ) tbuttonPtr->Handle;
				tbuttonPtr->DoubleBuffered = true;
				controlCount++;
			}
		} else if ( ThemeSetting.SkinTBitBtn && String( myForm->Components[ i ] ->ClassName() ) == "TBitBtn" ) {
			TBitBtn * tbitbtnPtr;
			tbitbtnPtr = ( TBitBtn * ) myForm->Components[ i ] ;
			if ( !AlreadySkin( ( unsigned int ) tbitbtnPtr->Handle ) ) {
				myControl[ controlCount ] = new TControlSubClass( myForm );
				myControl[ controlCount ] ->ControlType = "TBitBtn" ;
				myControl[ controlCount ] ->tbitbtnPtr = tbitbtnPtr;
				myControl[ controlCount ] ->myShare = myShare;
				myControl[ controlCount ] ->initCanvas() ;
				myControl[ controlCount ] ->ReplaceWProc( tbitbtnPtr->WindowProc );
				myControl[ controlCount ] ->myHandle = ( unsigned int ) tbitbtnPtr->Handle;
				tbitbtnPtr->DoubleBuffered = true;
				controlCount++;
			}
		} else if (ThemeSetting.SkinTRadioButton && String( myForm->Components[ i ] ->ClassName() ) == "TRadioButton" ) {
			TRadioButton * tradiobuttonPtr;
			tradiobuttonPtr = ( TRadioButton * ) myForm->Components[ i ] ;
			if ( !AlreadySkin( ( unsigned int ) tradiobuttonPtr->Handle ) ) {
				myControl[ controlCount ] = new TControlSubClass( myForm );
				myControl[ controlCount ] ->ControlType = "TRadioButton" ;
				myControl[ controlCount ] ->tradiobuttonPtr = tradiobuttonPtr;
				myControl[ controlCount ] ->myShare = myShare;
				myControl[ controlCount ] ->initCanvas() ;
				myControl[ controlCount ] ->ReplaceWProc( tradiobuttonPtr->WindowProc );
				myControl[ controlCount ] ->myHandle = ( unsigned int ) tradiobuttonPtr->Handle;
				tradiobuttonPtr->DoubleBuffered = true;
				controlCount++;
			}
		} else if ( ThemeSetting.SkinTCheckBox && String( myForm->Components[ i ] ->ClassName() ) == "TCheckBox" ) {
			TCheckBox * tcheckboxPtr;
			tcheckboxPtr = ( TCheckBox * ) myForm->Components[ i ] ;
			if ( !AlreadySkin( ( unsigned int ) tcheckboxPtr->Handle ) ) {
				myControl[ controlCount ] = new TControlSubClass( myForm );
				myControl[ controlCount ] ->ControlType = "TCheckBox" ;
				myControl[ controlCount ] ->tcheckboxPtr = tcheckboxPtr;
				myControl[ controlCount ] ->myShare = myShare;
				myControl[ controlCount ] ->initCanvas() ;
				myControl[ controlCount ] ->ReplaceWProc( tcheckboxPtr->WindowProc );
				myControl[ controlCount ] ->myHandle = ( unsigned int ) tcheckboxPtr->Handle;
				tcheckboxPtr->DoubleBuffered = true;
				tcheckboxPtr->Repaint() ;
				controlCount++;
			}
		} else if ( ThemeSetting.SkinTComboBox && String( myForm->Components[ i ] ->ClassName() ) == "TComboBox" ) {
			TComboBox * tcomboboxPtr;
			tcomboboxPtr = ( TComboBox * ) myForm->Components[ i ] ;
			if ( !AlreadySkin( ( unsigned int ) tcomboboxPtr->Handle ) ) {
				myControl[ controlCount ] = new TControlSubClass( myForm );
				myControl[ controlCount ] ->ControlType = "TComboBox" ;
				myControl[ controlCount ] ->tcomboboxPtr = tcomboboxPtr;
				myControl[ controlCount ] ->myShare = myShare;
				myControl[ controlCount ] ->initCanvas() ;
				myControl[ controlCount ] ->ReplaceWProc( tcomboboxPtr->WindowProc );
				myControl[ controlCount ] ->myHandle = ( unsigned int ) tcomboboxPtr->Handle;
				tcomboboxPtr->DoubleBuffered = true;
				controlCount++;
			}
		} else if ( ThemeSetting.SkinTColorBox && String( myForm->Components[ i ] ->ClassName() ) == "TColorBox" ) {
			TColorBox * tcolorboxPtr;
			tcolorboxPtr = ( TColorBox * ) myForm->Components[ i ] ;
			if ( !AlreadySkin( ( unsigned int ) tcolorboxPtr->Handle ) ) {
				myControl[ controlCount ] = new TControlSubClass( myForm );
				myControl[ controlCount ] ->ControlType = "TColorBox" ;
				myControl[ controlCount ] ->tcolorboxPtr = tcolorboxPtr;
				myControl[ controlCount ] ->myShare = myShare;
				myControl[ controlCount ] ->initCanvas() ;
				myControl[ controlCount ] ->ReplaceWProc( tcolorboxPtr->WindowProc );
				myControl[ controlCount ] ->myHandle = ( unsigned int ) tcolorboxPtr->Handle;
				tcolorboxPtr->DoubleBuffered = true;
				controlCount++;
			}
		} else if ( ThemeSetting.SkinTPanel && String( myForm->Components[ i ] ->ClassName() ) == "TPanel" || String( myForm->Components[ i ] ->ClassName() ) == "TNaturePanel" ) {
			TPanel * tpanelPtr;
			tpanelPtr = ( TPanel * ) myForm->Components[ i ] ;
			if ( !AlreadySkin( ( unsigned int ) tpanelPtr->Handle ) ) {
				myControl[ controlCount ] = new TControlSubClass( myForm );
				myControl[ controlCount ] ->ControlType = "TPanel" ;
				myControl[ controlCount ] ->tpanelPtr = tpanelPtr;
				myControl[ controlCount ] ->myShare = myShare;
				myControl[ controlCount ] ->initCanvas() ;
				myControl[ controlCount ] ->myHandle = ( unsigned int ) tpanelPtr->Handle;
				myControl[ controlCount ] ->ReplaceWProc( tpanelPtr->WindowProc );
				tpanelPtr->DoubleBuffered = true;
				controlCount++;
			}
		} else if ( ThemeSetting.SkinTScrollBar && String( myForm->Components[ i ] ->ClassName() ) == "TScrollBar" ) {
			TScrollBar * tscrollbarPtr;
			tscrollbarPtr = ( TScrollBar * ) myForm->Components[ i ] ;
			if ( !AlreadySkin( ( unsigned int ) tscrollbarPtr->Handle ) ) {
				myControl[ controlCount ] = new TControlSubClass( myForm );
				myControl[ controlCount ] ->ControlType = "TScrollBar" ;
				myControl[ controlCount ] ->tscrollbarPtr = tscrollbarPtr;
				myControl[ controlCount ] ->myShare = myShare;
				myControl[ controlCount ] ->initCanvas() ;
				myControl[ controlCount ] ->ReplaceWProc( tscrollbarPtr->WindowProc );
				myControl[ controlCount ] ->myHandle = ( unsigned int ) tscrollbarPtr->Handle;
				tscrollbarPtr->DoubleBuffered = true;
				controlCount++;
			}
		} else if ( ThemeSetting.SkinTMemo && String( myForm->Components[ i ] ->ClassName() ) == "TMemo" ) {
			TMemo * tmemoPtr;
			tmemoPtr = ( TMemo * ) myForm->Components[ i ] ;
			if ( !AlreadySkin( ( unsigned int ) tmemoPtr->Handle ) ) {
				myControl[ controlCount ] = new TControlSubClass( myForm );
				myControl[ controlCount ] ->ControlType = "TMemo" ;
				myControl[ controlCount ] ->tmemoPtr = tmemoPtr;
				myControl[ controlCount ] ->myShare = myShare;
				myControl[ controlCount ] ->initCanvas() ;
				myControl[ controlCount ] ->ReplaceWProc( tmemoPtr->WindowProc );
				myControl[ controlCount ] ->myHandle = ( unsigned int ) tmemoPtr->Handle;
				tmemoPtr->DoubleBuffered = true;
				controlCount++;
			}
		} else if ( ThemeSetting.SkinTStringGrid && String( myForm->Components[ i ] ->ClassName() ) == "TStringGrid" ) {
			TStringGrid * tstringgridPtr;
			tstringgridPtr = ( TStringGrid * ) myForm->Components[ i ] ;
			if ( !AlreadySkin( ( unsigned int ) tstringgridPtr->Handle ) ) {
				myControl[ controlCount ] = new TControlSubClass( myForm );
				myControl[ controlCount ] ->ControlType = "TStringGrid" ;
				myControl[ controlCount ] ->tstringgridPtr = tstringgridPtr;
				myControl[ controlCount ] ->myShare = myShare;
				myControl[ controlCount ] ->initCanvas() ;
				myControl[ controlCount ] ->ReplaceWProc( tstringgridPtr->WindowProc );
				myControl[ controlCount ] ->myHandle = ( unsigned int ) tstringgridPtr->Handle;
				tstringgridPtr->DoubleBuffered = true;
				controlCount++;
			}
		} else if ( ThemeSetting.SkinTListBox && String( myForm->Components[ i ] ->ClassName() ) == "TListBox" ) {
			TListBox * tlistboxPtr;
			tlistboxPtr = ( TListBox * ) myForm->Components[ i ] ;
			if ( !AlreadySkin( ( unsigned int ) tlistboxPtr->Handle ) ) {
				myControl[ controlCount ] = new TControlSubClass( myForm );
				myControl[ controlCount ] ->ControlType = "TListBox" ;
				myControl[ controlCount ] ->tlistboxPtr = tlistboxPtr;
				myControl[ controlCount ] ->myShare = myShare;
				myControl[ controlCount ] ->initCanvas() ;
				myControl[ controlCount ] ->ReplaceWProc( tlistboxPtr->WindowProc );
				myControl[ controlCount ] ->myHandle = ( unsigned int ) tlistboxPtr->Handle;
				tlistboxPtr->DoubleBuffered = true;
				controlCount++;
			}
		} else if ( ThemeSetting.SkinTTreeView && String( myForm->Components[ i ] ->ClassName() ) == "TTreeView" ) {
			TTreeView * ttreeviewPtr;
			ttreeviewPtr = ( TTreeView * ) myForm->Components[ i ] ;
			if ( !AlreadySkin( ( unsigned int ) ttreeviewPtr->Handle ) ) {
				myControl[ controlCount ] = new TControlSubClass( myForm );
				myControl[ controlCount ] ->ControlType = "TTreeView" ;
				myControl[ controlCount ] ->ttreeviewPtr = ttreeviewPtr;
				myControl[ controlCount ] ->myShare = myShare;
				myControl[ controlCount ] ->initCanvas() ;
				myControl[ controlCount ] ->ReplaceWProc( ttreeviewPtr->WindowProc );
				myControl[ controlCount ] ->myHandle = ( unsigned int ) ttreeviewPtr->Handle;
				ttreeviewPtr->DoubleBuffered = true;
				controlCount++;
			}
		} else if ( ThemeSetting.SkinTListView && String( myForm->Components[ i ] ->ClassName() ) == "TListView" ) {
			TListView * tlistviewPtr;
			tlistviewPtr = ( TListView * ) myForm->Components[ i ] ;
			if ( !AlreadySkin( ( unsigned int ) tlistviewPtr->Handle ) ) {
				myControl[ controlCount ] = new TControlSubClass( myForm );
				myControl[ controlCount ] ->ControlType = "TListView" ;
				myControl[ controlCount ] ->tlistviewPtr = tlistviewPtr;
				myControl[ controlCount ] ->myShare = myShare;
				myControl[ controlCount ] ->initCanvas() ;
				myControl[ controlCount ] ->ReplaceWProc( tlistviewPtr->WindowProc );
				myControl[ controlCount ] ->myHandle = ( unsigned int ) tlistviewPtr->Handle;
				tlistviewPtr->DoubleBuffered = true;
				controlCount++;
			}
		} else if ( ThemeSetting.SkinTCheckListBox && String( myForm->Components[ i ] ->ClassName() ) == "TCheckListBox" ) {
			TCheckListBox * tchecklistboxPtr;
			tchecklistboxPtr = ( TCheckListBox * ) myForm->Components[ i ] ;
			if ( !AlreadySkin( ( unsigned int ) tchecklistboxPtr->Handle ) ) {
				myControl[ controlCount ] = new TControlSubClass( myForm );
				myControl[ controlCount ] ->ControlType = "TCheckListBox" ;
				myControl[ controlCount ] ->tchecklistboxPtr = tchecklistboxPtr;
				myControl[ controlCount ] ->myShare = myShare;
				myControl[ controlCount ] ->initCanvas() ;
				myControl[ controlCount ] ->ReplaceWProc( tchecklistboxPtr->WindowProc );
				myControl[ controlCount ] ->myHandle = ( unsigned int ) tchecklistboxPtr->Handle;
				tchecklistboxPtr->DoubleBuffered = true;
				controlCount++;
			}
		} else if ( ThemeSetting.SkinTDrawGrid && String( myForm->Components[ i ] ->ClassName() ) == "TDrawGrid" ) {
			TDrawGrid * tdrawgridPtr;
			tdrawgridPtr = ( TDrawGrid * ) myForm->Components[ i ] ;
			if ( !AlreadySkin( ( unsigned int ) tdrawgridPtr->Handle ) ) {
				myControl[ controlCount ] = new TControlSubClass( myForm );
				myControl[ controlCount ] ->ControlType = "TDrawGrid" ;
				myControl[ controlCount ] ->tdrawgridPtr = tdrawgridPtr;
				myControl[ controlCount ] ->myShare = myShare;
				myControl[ controlCount ] ->initCanvas() ;
				myControl[ controlCount ] ->ReplaceWProc( tdrawgridPtr->WindowProc );
				myControl[ controlCount ] ->myHandle = ( unsigned int ) tdrawgridPtr->Handle;
				tdrawgridPtr->DoubleBuffered = true;
				controlCount++;
			}
		} else if ( ThemeSetting.SkinTRadioGroup && String( myForm->Components[ i ] ->ClassName() ) == "TRadioGroup" ) {
			TRadioGroup * tradiogroupPtr;
			tradiogroupPtr = ( TRadioGroup * ) myForm->Components[ i ] ;
			if ( !AlreadySkin( ( unsigned int ) tradiogroupPtr->Handle ) ) {
				myControl[ controlCount ] = new TControlSubClass( myForm );
				myControl[ controlCount ] ->ControlType = "TRadioGroup" ;
				myControl[ controlCount ] ->tradiogroupPtr = tradiogroupPtr;
				myControl[ controlCount ] ->myShare = myShare;
				myControl[ controlCount ] ->initCanvas() ;
				myControl[ controlCount ] ->ReplaceWProc( tradiogroupPtr->WindowProc );
				myControl[ controlCount ] ->myHandle = ( unsigned int ) tradiogroupPtr->Handle;
				tradiogroupPtr->DoubleBuffered = true;
				controlCount++;
			}
		} else if ( ThemeSetting.SkinTGroupBox && String( myForm->Components[ i ] ->ClassName() ) == "TGroupBox" ) {
			TGroupBox * tgroupboxPtr;
			tgroupboxPtr = ( TGroupBox * ) myForm->Components[ i ] ;
			if ( !AlreadySkin( ( unsigned int ) tgroupboxPtr->Handle ) ) {
				myControl[ controlCount ] = new TControlSubClass( myForm );
				myControl[ controlCount ] ->ControlType = "TGroupBox" ;
				myControl[ controlCount ] ->tgroupboxPtr = tgroupboxPtr;
				myControl[ controlCount ] ->myShare = myShare;
				myControl[ controlCount ] ->initCanvas() ;
				myControl[ controlCount ] ->ReplaceWProc( tgroupboxPtr->WindowProc );
				myControl[ controlCount ] ->myHandle = ( unsigned int ) tgroupboxPtr->Handle;
				tgroupboxPtr->DoubleBuffered = true;
				controlCount++;
			}
		}
	}
//	ShowMessage("skin done");
	return true;
}

void __fastcall NatureSkin::FormSubClass( Messages::TMessage &Message )
{
	// This part is removed after Version 0.9
}
void __fastcall NatureSkin::Active() {
	int i;
	if ( isActived == true )
		return ;
	controlCount = 0;
	isActived = true;
//	ShowMessage("start");
	SkinControls();
}

void __fastcall NatureSkin::About() {
	AnsiString ProductName, ProductVersion, Author, Copyright, Comment, HomePage;
	ProductName = "NatureSkin";
	ProductVersion = "0.9 OpenSource Edition ( July,2006 Released )";
	Author = "Liu,Jiun-Jiue";
	Copyright = "Copyright(c) Liu,Jiun-Jiue,2006. Made In Taiwan";
	HomePage = "http://www.cs.nctu.edu.tw/~hank1985/opensource/natureskin/";
	Comment = "OpenSource Application Skin Library for C++Builder 5.0/6.0/2006";
	MessageBox( NULL, ( ProductName + AnsiString( "\n\t\tVersion:" ) + ProductVersion + AnsiString( "\n\tAuthor:" ) + Author + AnsiString( "\n\n\n\t\t" ) + Copyright + AnsiString( "\n\n\n" ) + Comment + "\n\nFor more information , please visit the official website:  " + HomePage ).c_str() , "About NatureSkin", MB_ICONINFORMATION );
}

Graphics::TBitmap* __fastcall NatureSkin::GetSkinBitmap(int Index)
{
	if( Index<MaxBmpFileLoad && Index>=0 )
		return naGE->bmpArray[Index];
	else
		return NULL;
}


int __fastcall NatureSkin::ReadResInteger(void *_instance,int _id)
{
	char mystr[16];
	memset( mystr , 0 , sizeof( mystr ) );
	LoadString( _instance , _id , mystr , sizeof( mystr ) );
	return atoi(mystr) ;
}

AnsiString __fastcall NatureSkin::ReadResString(void *_instance,int _id)
{
	char mystr[256];
	memset( mystr , 0 , sizeof( mystr ) );
	LoadString( _instance , _id , mystr , sizeof( mystr ) );
	return AnsiString( mystr );
}

void __fastcall NatureSkin::MakeBackground()
{
	//Prepare to be done.
}

#endif





























