#include "skinlib.h"
void TControlSubClass::DrawBackgroundImage( TControl* Control, TCanvas* DestCanvas ) {
	int i, j, k;
	Graphics::TBitmap *bmp = new Graphics::TBitmap;
	bmp->LoadFromResourceName( ( unsigned int ) HInstance , AnsiString( "Dialog" ) );
	for ( i = 0;i <= Control->Width ;i += bmp->Width ) {
		for ( j = 0;j <= Control->Height ;j += bmp->Height ) {
			DestCanvas->CopyRect( Rect( i, j, i + bmp->Width , j + bmp->Height ), bmp->Canvas, Rect( 0, 0, bmp->Width, bmp->Height ) );
		}
	}
	delete bmp;
}
// Bz󪺰T
void __fastcall TControlSubClass::ControlSubClass( Messages::TMessage &Message ) {
	// oͿ~A]C
	if ( IsBadHugeReadPtr( &freeze , ( UINT ) sizeof( bool ) ) )
		return ;
	if ( IsBadReadPtr( &freeze , ( UINT ) sizeof( bool ) ) )
		return ;
	// {ǳBz

	if ( freeze ) {
		orgWindowProc( Message );
	} else if ( ControlType == "TPageControl" ) {
		if ( Message.Msg == WM_PAINT || Message.Msg == WM_MOUSEMOVE || Message.Msg == WM_LBUTTONDOWN || Message.Msg == WM_LBUTTONUP
		        || Message.Msg == WM_KEYDOWN || Message.Msg == WM_KEYUP || Message.Msg == WM_LBUTTONDBLCLK
		        || Message.Msg == CM_MOUSEENTER || Message.Msg == CM_MOUSELEAVE || Message.Msg == WM_ERASEBKGND
		        || Message.Msg == WM_NCPAINT || Message.Msg == WM_SETFOCUS || Message.Msg == WM_KILLFOCUS ) {
			orgWindowProc( Message );
			//NۤvCanvasл\Wh
			// קK]wgQBCB VCLRF ӵoͿ~
			if ( IsBadHugeReadPtr( &freeze , ( UINT ) sizeof( bool ) ) )
				return ;
			if ( IsBadReadPtr( &freeze , ( UINT ) sizeof( bool ) ) )
				return ;
			if ( freeze )
				return ;
			if ( !tpagecontrolPtr )
				return ;
			//			if ( Message.Msg == WM_ERASEBKGND || Message.Msg == WM_PAINT )
			TPageControlMsg( Message.Msg );
		} else {
			//BitBlt(GetDC(ControlHandle),0,0,Width,Height,SkinImage->Canvas->Handle,0,0,SRCCOPY);
			orgWindowProc( Message );  //LTdI
		}
	} else if ( ControlType == "TButton" ) {
		if ( Message.Msg == WM_PAINT || Message.Msg == WM_MOUSEMOVE || Message.Msg == WM_LBUTTONDOWN || Message.Msg == WM_LBUTTONUP
		        || Message.Msg == WM_KEYDOWN || Message.Msg == WM_KEYUP || Message.Msg == WM_LBUTTONDBLCLK
		        || Message.Msg == CM_MOUSEENTER || Message.Msg == CM_MOUSELEAVE || Message.Msg == WM_ERASEBKGND
				|| Message.Msg == WM_SETTEXT || Message.Msg == WM_SETFOCUS || Message.Msg == WM_KILLFOCUS ) {

			orgWindowProc( Message );
			//NۤvCanvasл\Wh
			// קK]wgQBCB VCLRF ӵoͿ~
			if ( IsBadHugeReadPtr( &freeze , ( UINT ) sizeof( bool ) ) )
				return ;
			if ( IsBadReadPtr( &freeze , ( UINT ) sizeof( bool ) ) )
				return ;
			//                                        if( freeze ) return;
			if ( !tbuttonPtr )
				return ;

			if ( Message.Msg == WM_LBUTTONUP && myForm->FormStyle!=fsMDIChild ) {
				if ( strstr( tbuttonPtr->Name.c_str(), "NSkinButton" ) ) {
					tbuttonPtr->OnClick( tbuttonPtr ) ;
				}
			}


			HDC dc;
			dc = GetDC( tbuttonPtr->Handle );
			BitBlt( dc , 0, 0, tbuttonPtr->Width , tbuttonPtr->Height , SkinImage->Canvas->Handle, 0, 0, SRCCOPY );
			ReleaseDC( tbuttonPtr->Handle , dc );
			TButtonMsg( Message.Msg );

		} else {
			//BitBlt(GetDC(ControlHandle),0,0,Width,Height,SkinImage->Canvas->Handle,0,0,SRCCOPY);
			orgWindowProc( Message );  //LTdI
		}
	} else if ( ControlType == "TBitBtn" ) {
		if ( Message.Msg == WM_PAINT || Message.Msg == WM_MOUSEMOVE || Message.Msg == WM_LBUTTONDOWN || Message.Msg == WM_LBUTTONUP
		        || Message.Msg == WM_KEYDOWN || Message.Msg == WM_KEYUP || Message.Msg == WM_LBUTTONDBLCLK
		        || Message.Msg == CM_MOUSEENTER || Message.Msg == CM_MOUSELEAVE || Message.Msg == WM_ERASEBKGND
				|| Message.Msg == WM_SETTEXT || Message.Msg == WM_KILLFOCUS || Message.Msg == WM_NCPAINT ||Message.Msg ==WM_SETFOCUS ) {
			orgWindowProc( Message );
			//NۤvCanvasл\Wh
			// קK]wgQBCB VCLRF ӵoͿ~
			if ( IsBadHugeReadPtr( &freeze , ( UINT ) sizeof( bool ) ) )
				return ;
			if ( IsBadReadPtr( &freeze , ( UINT ) sizeof( bool ) ) )
				return ;
			//                                        if( freeze ) return;
			if ( !tbitbtnPtr )
				return ;
			HDC dc;
			dc = GetDC( tbitbtnPtr->Handle );
			BitBlt( dc , 0, 0, tbitbtnPtr->Width , tbitbtnPtr->Height , SkinImage->Canvas->Handle, 0, 0, SRCCOPY );
			ReleaseDC( tbitbtnPtr->Handle , dc );
			TBitBtnMsg( Message.Msg );
			if ( Message.Msg == WM_LBUTTONUP ) {
				if ( strstr( tbitbtnPtr->Name.c_str(), "NSkinBitBtn" ) ) {
					tbitbtnPtr->OnClick( tbitbtnPtr ) ;
				}
			}
		} else {
			//BitBlt(GetDC(ControlHandle),0,0,Width,Height,SkinImage->Canvas->Handle,0,0,SRCCOPY);
			orgWindowProc( Message );  //LTdI
		}
	} else if ( ControlType == "TRadioButton" ) {
		if ( Message.Msg == BM_SETCHECK || Message.Msg == BM_GETCHECK || Message.Msg == WM_PAINT || Message.Msg == WM_LBUTTONDOWN || Message.Msg == WM_LBUTTONUP
		        || Message.Msg == WM_KEYDOWN || Message.Msg == WM_KEYUP || Message.Msg == WM_LBUTTONDBLCLK
		        || Message.Msg == CM_MOUSEENTER || Message.Msg == CM_MOUSELEAVE || Message.Msg == WM_ERASEBKGND
				|| Message.Msg == WM_SETTEXT ) {
			//                        BitBlt( dc , 0,0,tradiobuttonPtr->Width , tradiobuttonPtr->Height , SkinImage->Canvas->Handle, 0,0, SRCERASE );
			TBrush * bsh = new TBrush;
			if ( !IsBadHugeReadPtr( &freeze , ( UINT ) sizeof( bool ) ) && !IsBadReadPtr( &freeze , ( UINT ) sizeof( bool ) ) ) {
				//                                bsh->Color = RGB(0,0,255);
				//                                bsh->Style =bsClear;
				//                                bsh->Style = bsSolid;
				//                                ::SetClassLong( tradiobuttonPtr->Handle , GCL_HBRBACKGROUND , (LONG)(bsh->Handle) );
			}
			orgWindowProc( Message );
			//                        EndPaint(tradiobuttonPtr->Handle,&ps);
			//NۤvCanvasл\Wh
			if ( IsBadHugeReadPtr( &freeze , ( UINT ) sizeof( bool ) ) )
				return ;
			if ( IsBadReadPtr( &freeze , ( UINT ) sizeof( bool ) ) )
				return ;
			delete bsh;
			HDC dc;
			dc = GetDC( tradiobuttonPtr->Handle );
			BitBlt( dc , 0, 0, tradiobuttonPtr->Width , tradiobuttonPtr->Height , SkinImage->Canvas->Handle, 0, 0, SRCCOPY );
			ReleaseDC( tradiobuttonPtr->Handle , dc );

			TRadioButtonMsg( Message.Msg );
		} else {
			orgWindowProc( Message );  //LTdI
		}
	} else if ( ControlType == "TCheckBox" ) {
		if ( Message.Msg == BM_SETCHECK || Message.Msg == BM_GETCHECK || Message.Msg == WM_PAINT || Message.Msg == WM_MOUSEMOVE || Message.Msg == WM_LBUTTONDOWN || Message.Msg == WM_LBUTTONUP
		        || Message.Msg == WM_KEYDOWN || Message.Msg == WM_KEYUP || Message.Msg == WM_LBUTTONDBLCLK
		        || Message.Msg == CM_MOUSEENTER || Message.Msg == CM_MOUSELEAVE || Message.Msg == WM_ERASEBKGND
				|| Message.Msg == WM_SETTEXT || Message.Msg == WM_SETFOCUS ) {
			//BzӪT
			//eh@IAOFקKTButtonϤSX
			//                                        BitBlt(GetDC(ControlHandle),0,0,Width,Height,SkinImage->Canvas->Handle,0,0,SRCCOPY);
			orgWindowProc( Message );
			//                                        BitBlt(GetDC(ControlHandle),0,0,Width,Height,SkinImage->Canvas->Handle,0,0,SRCCOPY);
			//NۤvCanvasл\Wh
			if ( IsBadHugeReadPtr( &freeze , ( UINT ) sizeof( bool ) ) )
				return ;
			if ( IsBadReadPtr( &freeze , ( UINT ) sizeof( bool ) ) )
				return ;
			HDC dc;
			dc = GetDC( tcheckboxPtr->Handle );
			BitBlt( dc , 0, 0, tcheckboxPtr->Width , tcheckboxPtr->Height , SkinImage->Canvas->Handle, 0, 0, SRCCOPY );
			ReleaseDC( tcheckboxPtr->Handle , dc );

			TCheckBoxMsg( Message.Msg );
		} else {
			orgWindowProc( Message );  //LTdI
		}
	} else if ( ControlType == "TComboBox" ) {
		if ( Message.Msg == WM_KILLFOCUS || Message.Msg == BM_GETCHECK || Message.Msg == WM_PAINT || Message.Msg == WM_MOUSEMOVE || Message.Msg == WM_LBUTTONDOWN || Message.Msg == WM_LBUTTONUP
		        || Message.Msg == WM_KEYDOWN || Message.Msg == WM_KEYUP || Message.Msg == WM_LBUTTONDBLCLK
		        || Message.Msg == CM_MOUSEENTER || Message.Msg == CM_MOUSELEAVE || Message.Msg == WM_ERASEBKGND
				|| Message.Msg == WM_NCPAINT || Message.Msg == WM_SETFOCUS ) {
			//BzӪT
			//eh@IAOFקKTButtonϤSX
			//                                        BitBlt(GetDC(ControlHandle),0,0,Width,Height,SkinImage->Canvas->Handle,0,0,SRCCOPY);
			orgWindowProc( Message );
			//                                        BitBlt(GetDC(ControlHandle),0,0,Width,Height,SkinImage->Canvas->Handle,0,0,SRCCOPY);
			//NۤvCanvasл\Wh
			if ( IsBadHugeReadPtr( &freeze , ( UINT ) sizeof( bool ) ) )
				return ;
			if ( IsBadReadPtr( &freeze , ( UINT ) sizeof( bool ) ) )
				return ;

			TComboBoxMsg( Message.Msg );
		} else {
			orgWindowProc( Message );  //LTdI
		}
	} else if ( ControlType == "TColorBox" ) {
		if ( Message.Msg == WM_KILLFOCUS || Message.Msg == BM_GETCHECK || Message.Msg == WM_PAINT || Message.Msg == WM_MOUSEMOVE || Message.Msg == WM_LBUTTONDOWN || Message.Msg == WM_LBUTTONUP
		        || Message.Msg == WM_KEYDOWN || Message.Msg == WM_KEYUP || Message.Msg == WM_LBUTTONDBLCLK
		        || Message.Msg == CM_MOUSEENTER || Message.Msg == CM_MOUSELEAVE || Message.Msg == WM_ERASEBKGND
				|| Message.Msg == WM_NCPAINT || Message.Msg == WM_SETFOCUS ) {
			//BzӪT
			//eh@IAOFקKTButtonϤSX
			//                                        BitBlt(GetDC(ControlHandle),0,0,Width,Height,SkinImage->Canvas->Handle,0,0,SRCCOPY);
			orgWindowProc( Message );
			//                                        BitBlt(GetDC(ControlHandle),0,0,Width,Height,SkinImage->Canvas->Handle,0,0,SRCCOPY);
			//NۤvCanvasл\Wh
			if ( IsBadHugeReadPtr( &freeze , ( UINT ) sizeof( bool ) ) )
				return ;
			if ( IsBadReadPtr( &freeze , ( UINT ) sizeof( bool ) ) )
				return ;

			TColorBoxMsg( Message.Msg );
		} else {
			orgWindowProc( Message );  //LTdI
		}
	} else if ( ControlType == "TPanel" ) {
		if ( Message.Msg == WM_PAINT || Message.Msg == WM_LBUTTONDOWN || Message.Msg == WM_LBUTTONUP
		        || Message.Msg == WM_KEYDOWN || Message.Msg == WM_KEYUP || Message.Msg == WM_LBUTTONDBLCLK
				|| Message.Msg == CM_MOUSEENTER || Message.Msg == CM_MOUSELEAVE || Message.Msg == WM_ERASEBKGND
				|| Message.Msg == WM_NCPAINT || Message.Msg == WM_NCLBUTTONUP || Message.Msg == WM_SIZING || Message.Msg == WM_NCHITTEST ||Message.Msg ==WM_SETTEXT ) {
			//BzӪT
			//eh@IAOFקKTButtonϤSX
			//WM_SIZE			//                                        BitBlt(GetDC(ControlHandle),0,0,Width,Height,SkinImage->Canvas->Handle,0,0,SRCCOPY);
			if ( Message.Msg == WM_ERASEBKGND ) {
				Message.Result = 1;
			} else
				orgWindowProc( Message );
			//                                        BitBlt(GetDC(ControlHandle),0,0,Width,Height,SkinImage->Canvas->Handle,0,0,SRCCOPY);
			//NۤvCanvasл\Wh
			if ( IsBadHugeReadPtr( &freeze , ( UINT ) sizeof( bool ) ) )
				return ;
			if ( IsBadReadPtr( &freeze , ( UINT ) sizeof( bool ) ) )
				return ;

			TPanelMsg( Message.Msg );
			// UOd
			/*                        if( Message.Msg == WM_LBUTTONUP ){
											int fwKeys,xPos,yPos;
											TMouseButton tmb;
											TShiftState tss;
											fwKeys = Message.WParam;        // key flags
											xPos = LOWORD(Message.LParam);  // horizontal position of cursor
											yPos = HIWORD(Message.LParam);  // vertical position of cursor
			                                tmb=mbLeft;
			                                if( fwKeys & MK_CONTROL ) tss<<ssCtrl;
			                                if( fwKeys & MK_MBUTTON ) tss<<ssMiddle;
			                                if( fwKeys & MK_RBUTTON ) tss<<ssRight;
											if( fwKeys & MK_SHIFT ) tss<<ssShift;
											if( strstr(tpanelPtr->Name.c_str(),"NSkinPanel") ){
													tpanelPtr->OnMouseUp( tpanelPtr , tmb , tss , xPos , yPos ) ;
											}
									}*/
		} else {
			orgWindowProc( Message );  //LTdI
		}
	} else if ( ControlType == "TRadioGroup" ) {
		if ( Message.Msg == WM_PAINT || Message.Msg == WM_LBUTTONDOWN || Message.Msg == WM_LBUTTONUP
		        || Message.Msg == WM_KEYDOWN || Message.Msg == WM_KEYUP || Message.Msg == WM_LBUTTONDBLCLK
		        || Message.Msg == CM_MOUSEENTER || Message.Msg == CM_MOUSELEAVE || Message.Msg == WM_ERASEBKGND
				|| Message.Msg == WM_PRINT || Message.Msg == WM_NCLBUTTONUP || Message.Msg == WM_SIZING || Message.Msg == WM_NCHITTEST || Message.Msg ==WM_SETTEXT ) {
			//BzӪT
			//eh@IAOFקKTButtonϤSX
			//WM_SIZE			//                                        BitBlt(GetDC(ControlHandle),0,0,Width,Height,SkinImage->Canvas->Handle,0,0,SRCCOPY);
			orgWindowProc( Message );
			//                                        BitBlt(GetDC(ControlHandle),0,0,Width,Height,SkinImage->Canvas->Handle,0,0,SRCCOPY);
			//NۤvCanvasл\Wh
			if ( IsBadHugeReadPtr( &freeze , ( UINT ) sizeof( bool ) ) )
				return ;
			if ( IsBadReadPtr( &freeze , ( UINT ) sizeof( bool ) ) )
				return ;

			TRadioGroupMsg( Message.Msg );
			// UOd
			/*                        if( Message.Msg == WM_LBUTTONUP ){
											int fwKeys,xPos,yPos;
											TMouseButton tmb;
											TShiftState tss;
											fwKeys = Message.WParam;        // key flags
											xPos = LOWORD(Message.LParam);  // horizontal position of cursor
											yPos = HIWORD(Message.LParam);  // vertical position of cursor
											tmb=mbLeft;
											if( fwKeys & MK_CONTROL ) tss<<ssCtrl;
											if( fwKeys & MK_MBUTTON ) tss<<ssMiddle;
											if( fwKeys & MK_RBUTTON ) tss<<ssRight;
											if( fwKeys & MK_SHIFT ) tss<<ssShift;
											if( strstr(tradiogroupPtr->Name.c_str(),"NSkinRadioGroup") ){
													tradiogroupPtr->OnMouseUp( tradiogroupPtr , tmb , tss , xPos , yPos ) ;
											}
									}*/
		} else {
			orgWindowProc( Message );  //LTdI
		}
	} else if ( ControlType == "TGroupBox" ) {
		if ( Message.Msg == WM_PAINT || Message.Msg == WM_LBUTTONDOWN || Message.Msg == WM_LBUTTONUP
		        || Message.Msg == WM_KEYDOWN || Message.Msg == WM_KEYUP || Message.Msg == WM_LBUTTONDBLCLK
		        || Message.Msg == CM_MOUSEENTER || Message.Msg == CM_MOUSELEAVE || Message.Msg == WM_ERASEBKGND
				|| Message.Msg == WM_PRINT || Message.Msg == WM_NCLBUTTONUP || Message.Msg == WM_SIZING || Message.Msg == WM_NCHITTEST ||Message.Msg ==WM_SETTEXT ) {
			//BzӪT
			//eh@IAOFקKTButtonϤSX
			//WM_SIZE			//                                        BitBlt(GetDC(ControlHandle),0,0,Width,Height,SkinImage->Canvas->Handle,0,0,SRCCOPY);
			orgWindowProc( Message );
			//                                        BitBlt(GetDC(ControlHandle),0,0,Width,Height,SkinImage->Canvas->Handle,0,0,SRCCOPY);
			//NۤvCanvasл\Wh
			if ( IsBadHugeReadPtr( &freeze , ( UINT ) sizeof( bool ) ) )
				return ;
			if ( IsBadReadPtr( &freeze , ( UINT ) sizeof( bool ) ) )
				return ;

			TGroupBoxMsg( Message.Msg );
			// UOd
			/*                        if( Message.Msg == WM_LBUTTONUP ){
											int fwKeys,xPos,yPos;
											TMouseButton tmb;
											TShiftState tss;
											fwKeys = Message.WParam;        // key flags
											xPos = LOWORD(Message.LParam);  // horizontal position of cursor
											yPos = HIWORD(Message.LParam);  // vertical position of cursor
											tmb=mbLeft;
											if( fwKeys & MK_CONTROL ) tss<<ssCtrl;
											if( fwKeys & MK_MBUTTON ) tss<<ssMiddle;
											if( fwKeys & MK_RBUTTON ) tss<<ssRight;
											if( fwKeys & MK_SHIFT ) tss<<ssShift;
											if( strstr(tgroupboxPtr->Name.c_str(),"NSkinGroupBox") ){
													tgroupboxPtr->OnMouseUp( tgroupboxPtr , tmb , tss , xPos , yPos ) ;
											}
									}*/
		} else {
			orgWindowProc( Message );  //LTdI
		}
	} else if ( ControlType == "TScrollBar" ) {
		if ( Message.Msg == SBM_SETPOS || Message.Msg == WM_LBUTTONDOWN || Message.Msg == WM_LBUTTONDBLCLK || Message.Msg == WM_LBUTTONUP || Message.Msg == SBM_SETRANGE || Message.Msg == WM_PAINT
		        || Message.Msg == SBM_SETRANGEREDRAW || Message.Msg == SBM_SETSCROLLINFO
		        || Message.Msg == WM_CTLCOLORSCROLLBAR || Message.Msg == SBM_ENABLE_ARROWS ) {
			//BzӪT
			//eh@IAOFקKTButtonϤSX
			//                                        BitBlt(GetDC(ControlHandle),0,0,Width,Height,SkinImage->Canvas->Handle,0,0,SRCCOPY);

			orgWindowProc( Message );
			//                                        BitBlt(GetDC(ControlHandle),0,0,Width,Height,SkinImage->Canvas->Handle,0,0,SRCCOPY);
			//NۤvCanvasл\Wh
			if ( IsBadHugeReadPtr( &freeze , ( UINT ) sizeof( bool ) ) )
				return ;
			if ( IsBadReadPtr( &freeze , ( UINT ) sizeof( bool ) ) )
				return ;
			TScrollBarMsg( Message.Msg );

		} else {
			orgWindowProc( Message );  //LTdI
		}
	} else if ( ControlType == "TMemo" ) {
		if ( Message.Msg == WM_VSCROLL || Message.Msg == WM_HSCROLL || Message.Msg == WM_LBUTTONDBLCLK || Message.Msg == WM_LBUTTONUP || Message.Msg == SBM_SETRANGE || Message.Msg == WM_NCPAINT
		        || Message.Msg == CM_MOUSEENTER || Message.Msg == SBM_SETSCROLLINFO
				|| Message.Msg == WM_CTLCOLORSCROLLBAR || Message.Msg == WM_PAINT ) {
			//BzӪT
			//eh@IAOFקKTButtonϤSX
			//                                        BitBlt(GetDC(ControlHandle),0,0,Width,Height,SkinImage->Canvas->Handle,0,0,SRCCOPY);

			orgWindowProc( Message );
			//                                        BitBlt(GetDC(ControlHandle),0,0,Width,Height,SkinImage->Canvas->Handle,0,0,SRCCOPY);
			//NۤvCanvasл\Wh
			if ( IsBadHugeReadPtr( &freeze , ( UINT ) sizeof( bool ) ) )
				return ;
			if ( IsBadReadPtr( &freeze , ( UINT ) sizeof( bool ) ) )
				return ;
			TMemoMsg( Message.Msg );

		} else {
			orgWindowProc( Message );  //LTdI
		}
	} else if ( ControlType == "TStringGrid" ) {
		if ( Message.Msg == SBM_SETPOS || Message.Msg == WM_LBUTTONDOWN || Message.Msg == WM_LBUTTONDBLCLK || Message.Msg == WM_LBUTTONUP || Message.Msg == SBM_SETRANGE || Message.Msg == WM_PAINT
		        || Message.Msg == CM_MOUSEENTER || Message.Msg == SBM_SETSCROLLINFO
		        || Message.Msg == WM_CTLCOLORSCROLLBAR || Message.Msg == SBM_ENABLE_ARROWS ) {
			//BzӪT
			//eh@IAOFקKTButtonϤSX
			//                                        BitBlt(GetDC(ControlHandle),0,0,Width,Height,SkinImage->Canvas->Handle,0,0,SRCCOPY);

			orgWindowProc( Message );
			//                                        BitBlt(GetDC(ControlHandle),0,0,Width,Height,SkinImage->Canvas->Handle,0,0,SRCCOPY);
			//NۤvCanvasл\Wh
			if ( IsBadHugeReadPtr( &freeze , ( UINT ) sizeof( bool ) ) )
				return ;
			if ( IsBadReadPtr( &freeze , ( UINT ) sizeof( bool ) ) )
				return ;
			TStringGridMsg( Message.Msg );
		} else {
			orgWindowProc( Message );  //LTdI
		}
	} else if ( ControlType == "TListBox" ) {
		if ( Message.Msg == SBM_SETPOS || Message.Msg == WM_LBUTTONDOWN || Message.Msg == WM_LBUTTONDBLCLK || Message.Msg == WM_LBUTTONUP || Message.Msg == SBM_SETRANGE || Message.Msg == WM_PAINT
		        || Message.Msg == CM_MOUSEENTER || Message.Msg == SBM_SETSCROLLINFO
		        || Message.Msg == WM_CTLCOLORSCROLLBAR || Message.Msg == SBM_ENABLE_ARROWS ) {
			//BzӪT
			//eh@IAOFקKTButtonϤSX
			//                                        BitBlt(GetDC(ControlHandle),0,0,Width,Height,SkinImage->Canvas->Handle,0,0,SRCCOPY);

			orgWindowProc( Message );
			//                                        BitBlt(GetDC(ControlHandle),0,0,Width,Height,SkinImage->Canvas->Handle,0,0,SRCCOPY);
			//NۤvCanvasл\Wh
			if ( IsBadHugeReadPtr( &freeze , ( UINT ) sizeof( bool ) ) )
				return ;
			if ( IsBadReadPtr( &freeze , ( UINT ) sizeof( bool ) ) )
				return ;
			TListBoxMsg( Message.Msg );
		} else {
			orgWindowProc( Message );  //LTdI
		}
	} else if ( ControlType == "TTreeView" ) {
		if ( Message.Msg == SBM_SETPOS || Message.Msg == WM_LBUTTONDOWN || Message.Msg == WM_LBUTTONDBLCLK || Message.Msg == WM_LBUTTONUP || Message.Msg == SBM_SETRANGE || Message.Msg == WM_PAINT
		        || Message.Msg == CM_MOUSEENTER || Message.Msg == SBM_SETSCROLLINFO
		        || Message.Msg == WM_CTLCOLORSCROLLBAR || Message.Msg == SBM_ENABLE_ARROWS ) {
			//BzӪT
			//eh@IAOFקKTButtonϤSX
			//                                        BitBlt(GetDC(ControlHandle),0,0,Width,Height,SkinImage->Canvas->Handle,0,0,SRCCOPY);

			orgWindowProc( Message );
			//                                        BitBlt(GetDC(ControlHandle),0,0,Width,Height,SkinImage->Canvas->Handle,0,0,SRCCOPY);
			//NۤvCanvasл\Wh
			if ( IsBadHugeReadPtr( &freeze , ( UINT ) sizeof( bool ) ) )
				return ;
			if ( IsBadReadPtr( &freeze , ( UINT ) sizeof( bool ) ) )
				return ;
			TTreeViewMsg( Message.Msg );
		} else {
			orgWindowProc( Message );  //LTdI
		}
	} else if ( ControlType == "TListView" ) {
		if ( Message.Msg == SBM_SETPOS || Message.Msg == WM_HSCROLL || Message.Msg == WM_NCPAINT || Message.Msg == WM_LBUTTONUP || Message.Msg == SBM_SETRANGE || Message.Msg == WM_PAINT
		        || Message.Msg == WM_VSCROLL || Message.Msg == SBM_SETSCROLLINFO
		        || Message.Msg == LVM_SCROLL || Message.Msg == SBM_ENABLE_ARROWS ) {
			//BzӪT
			//eh@IAOFקKTButtonϤSX
			//                                        BitBlt(GetDC(ControlHandle),0,0,Width,Height,SkinImage->Canvas->Handle,0,0,SRCCOPY);

			orgWindowProc( Message );
			//                                        BitBlt(GetDC(ControlHandle),0,0,Width,Height,SkinImage->Canvas->Handle,0,0,SRCCOPY);
			//			myForm->Caption ="!!";
			//NۤvCanvasл\Wh
			if ( IsBadHugeReadPtr( &freeze , ( UINT ) sizeof( bool ) ) )
				return ;
			if ( IsBadReadPtr( &freeze , ( UINT ) sizeof( bool ) ) )
				return ;
			TListViewMsg( Message.Msg );
		} else {
			orgWindowProc( Message );  //LTdI
		}
	} else if ( ControlType == "TCheckListBox" ) {
		if ( Message.Msg == SBM_SETPOS || Message.Msg == WM_LBUTTONDOWN || Message.Msg == WM_LBUTTONDBLCLK || Message.Msg == WM_LBUTTONUP || Message.Msg == SBM_SETRANGE || Message.Msg == WM_PAINT
		        || Message.Msg == CM_MOUSEENTER || Message.Msg == SBM_SETSCROLLINFO
		        || Message.Msg == WM_CTLCOLORSCROLLBAR || Message.Msg == SBM_ENABLE_ARROWS ) {
			//BzӪT
			//eh@IAOFקKTButtonϤSX
			//                                        BitBlt(GetDC(ControlHandle),0,0,Width,Height,SkinImage->Canvas->Handle,0,0,SRCCOPY);

			orgWindowProc( Message );
			//                                        BitBlt(GetDC(ControlHandle),0,0,Width,Height,SkinImage->Canvas->Handle,0,0,SRCCOPY);
			//NۤvCanvasл\Wh
			if ( IsBadHugeReadPtr( &freeze , ( UINT ) sizeof( bool ) ) )
				return ;
			if ( IsBadReadPtr( &freeze , ( UINT ) sizeof( bool ) ) )
				return ;
			TCheckListBoxMsg( Message.Msg );
		} else {
			orgWindowProc( Message );  //LTdI
		}
	} else if ( ControlType == "TDrawGrid" ) {
		if ( Message.Msg == SBM_SETPOS || Message.Msg == WM_LBUTTONDOWN || Message.Msg == WM_LBUTTONDBLCLK || Message.Msg == WM_LBUTTONUP || Message.Msg == SBM_SETRANGE || Message.Msg == WM_PAINT
		        || Message.Msg == CM_MOUSEENTER || Message.Msg == SBM_SETSCROLLINFO
		        || Message.Msg == WM_CTLCOLORSCROLLBAR || Message.Msg == SBM_ENABLE_ARROWS ) {
			//BzӪT
			//eh@IAOFקKTButtonϤSX
			//                                        BitBlt(GetDC(ControlHandle),0,0,Width,Height,SkinImage->Canvas->Handle,0,0,SRCCOPY);

			orgWindowProc( Message );
			//                                        BitBlt(GetDC(ControlHandle),0,0,Width,Height,SkinImage->Canvas->Handle,0,0,SRCCOPY);
			//NۤvCanvasл\Wh
			if ( IsBadHugeReadPtr( &freeze , ( UINT ) sizeof( bool ) ) )
				return ;
			if ( IsBadReadPtr( &freeze , ( UINT ) sizeof( bool ) ) )
				return ;
			TDrawGridMsg( Message.Msg );
		} else {
			orgWindowProc( Message );  //LTdI
		}
	} else
		orgWindowProc( Message ); // 󤣳QNatureSkinҤ䴩



}
__fastcall TControlSubClass::TControlSubClass( TForm *AOwner ) : Classes::TComponent( AOwner ) {
	// lưʧ@
	int i;
	Style = 0;
	mdown = false;
	mmove = false;
	getfocus = false;
	freeze = false;
	tbuttonPtr = NULL;
	tbitbtnPtr = NULL;
	tradiobuttonPtr = NULL;
	tcheckboxPtr = NULL;
	tpanelPtr = NULL;
	tcomboboxPtr = NULL;
	tcolorboxPtr = NULL;
	tscrollbarPtr = NULL;
	tpagecontrolPtr = NULL;
	tmemoPtr = NULL;
	tstringgridPtr = NULL;
	tdrawgridPtr = NULL;
	tlistboxPtr = NULL;
	ttreeviewPtr = NULL;
	tlistviewPtr = NULL;
	tchecklistboxPtr = NULL;
	tradiogroupPtr = NULL;
	tgroupboxPtr = NULL;
	nscrollbar = NULL;
	nscrollbar2 = NULL;

	myForm = AOwner;

	for ( i = 0;i < 64;i++ ) {
		pageButton[ i ] = NULL;
	}

	// إߨϥβHXHJSĪpɾ

	tbuttonTimer = new TTimer( myForm );
	tbuttonTimer->Enabled = false;
	tbuttonTimer->OnTimer = tbuttonOnTimer;
	tbitbtnTimer = new TTimer( myForm );
	tbitbtnTimer->Enabled = false;
	tbitbtnTimer->OnTimer = tbitbtnOnTimer;

	// إ߷|ϥΨ쪺 Bitmap 

	SkinImage = new Graphics::TBitmap(); // xsCӤWϹ
	bmpBuffer = new Graphics::TBitmap(); 	

	/*	for ( i = 0;i < 3;i++ )
			resourceImage[ i ] = new Graphics::TBitmap(); // q귽ŪXϤ|ΨC
	  */

}
__fastcall TControlSubClass::~TControlSubClass( void ) {
	int i;
	/*	if ( ControlType == "TComboBox" ) {
			HRGN rethRgn;
			rethRgn = CreateRoundRectRgn( 0, 0, tcomboboxPtr->Width + 1, tcomboboxPtr->Height + 1, 0, 0 );
			SetWindowRgn( tcomboboxPtr->Handle , rethRgn, True );
		} else if ( ControlType == "TPanel" ) {
			//		HRGN rethRgn;
			//		rethRgn = CreateRoundRectRgn( 0, 0, tpanelPtr->Width + 1, tpanelPtr->Height + 1, 0, 0 );
			//		SetWindowRgn( tpanelPtr->Handle , rethRgn, True );
		}*/ 
	//ɱNҫإߪŶFree
	Style = 0;
	mdown = false;
	mmove = false;
	getfocus = false;
	tbuttonPtr = NULL;
	tbitbtnPtr = NULL;
	tradiobuttonPtr = NULL;
	tcheckboxPtr = NULL;
	tpanelPtr = NULL;
	tcomboboxPtr = NULL;
	tcolorboxPtr = NULL;
	tscrollbarPtr = NULL;
	tpagecontrolPtr = NULL;
	tradiogroupPtr = NULL;
	tmemoPtr = NULL;
	tstringgridPtr = NULL;
	tdrawgridPtr = NULL;
	tlistboxPtr = NULL;
	ttreeviewPtr = NULL;
	tlistviewPtr = NULL;
	tchecklistboxPtr = NULL;
	tgroupboxPtr = NULL;
	tbuttonTimer->Enabled = false;
	tbitbtnTimer->Enabled = false;
	delete tbuttonTimer;
	delete tbitbtnTimer;

	// nscrollbar ݭnSkinLib.cpp̭
	// YbBN|ͰD


	for ( i = 0;i < 64;i++ ) {
		if ( pageButton[ i ] != NULL ) {
			delete pageButton[ i ];
			pageButton[ i ] = NULL;
		}
	}
	// MBitmap

	if ( SkinImage != NULL ) {
		delete SkinImage;
		SkinImage = NULL;
	}
	if ( bmpBuffer != NULL ) {
		delete bmpBuffer;
		bmpBuffer = NULL;
	}
	/*	for ( i = 0;i < 3;i++ )
			if ( resourceImage[ i ] != NULL ) {
				delete resourceImage[ i ];
				resourceImage[ i ] = NULL;
			}*/
}
void __fastcall TControlSubClass::loadResourceImage()
{
	// q귽ɸJv



}
// lƵe
void __fastcall TControlSubClass::initCanvas() {
	int i;

	if ( ControlType == "TButton" ) {
		SkinImage->Width = tbuttonPtr->Width;
		SkinImage->Height = tbuttonPtr->Height;
		//]wIզ⬰z
/*		SkinImage->Transparent = true;
		SkinImage->TransparentColor = clWhite;
		SkinImage->TransparentMode = tmAuto;*/
		loadResourceImage();
		//el
		DrawButton( 0, 0 );
	} else if ( ControlType == "TBitBtn" ) {
		Style = 0;
		SkinImage->Width = tbitbtnPtr->Width;
		SkinImage->Height = tbitbtnPtr->Height;
		loadResourceImage();
		//el
		if ( Style == 0 ) {
			DrawBitBtn( 0, 0 );
			//			HRGN rethRgn;
			///			rethRgn = CreateRoundRectRgn( 0, 0, tbitbtnPtr->Width + 1, tbitbtnPtr->Height + 1, 12, 12 );
			//			SetWindowRgn( tbitbtnPtr->Handle , rethRgn, True );
		}
	} else if ( ControlType == "TRadioButton" ) {
		SkinImage->Width = tradiobuttonPtr->Width;
		SkinImage->Height = tradiobuttonPtr->Height;
		loadResourceImage();
		//el
		DrawRadioButton( 0, 0 );
	} else if ( ControlType == "TCheckBox" ) {
		SkinImage->Width = tcheckboxPtr->Width;
		SkinImage->Height = tcheckboxPtr->Height;
		loadResourceImage();
		//el
		if ( Style == 0 ) {
			DrawCheckBox( 0, 0 );

		}
	} else if ( ControlType == "TComboBox" ) {
		SkinImage->Width = tcomboboxPtr->Width;
		SkinImage->Height = tcomboboxPtr->Height;
		loadResourceImage();
		//el
		if ( Style == 0 ) {
			DrawComboBox( 0, 0 );
		}
	} else if ( ControlType == "TColorBox" ) {
		SkinImage->Width = tcolorboxPtr->Width;
		SkinImage->Height = tcolorboxPtr->Height;
		loadResourceImage();
		//el
		if ( Style == 0 ) {
			DrawColorBox( 0, 0 );
		}
	} else if ( ControlType == "TPanel" ) {
		SkinImage->Width = tpanelPtr->Width;
		SkinImage->Height = tpanelPtr->Height;
		loadResourceImage();
		//el
		if ( Style == 0 ) {
			DrawPanel( 0, 0 );
		}
	} else if ( ControlType == "TRadioGroup" ) {
		SkinImage->Width = tradiogroupPtr->Width;
		SkinImage->Height = tradiogroupPtr->Height;
		loadResourceImage();
		//el
		if ( Style == 0 ) {
			DrawRadioGroup( 0, 0 );
		}
	} else if ( ControlType == "TGroupBox" ) {
		SkinImage->Width = tgroupboxPtr->Width;
		SkinImage->Height = tgroupboxPtr->Height;
		loadResourceImage();
		//el
		if ( Style == 0 ) {
			DrawGroupBox( 0, 0 );
		}
	} else if ( ControlType == "TMemo" ) {
		//SkinImage->Width = tmemoPtr->Width;
		//SkinImage->Height = tmemoPtr->Height;
		//		ShowMessage("@");
		nscrollbar = new NScrollBar( myForm, tmemoPtr );
		nscrollbar2 = new NScrollBar( myForm, tmemoPtr );
		nscrollbar->setVertical() ;
		nscrollbar->init() ;
		nscrollbar2->setHorizontal() ;
		nscrollbar2->init() ;
		loadResourceImage();
		//el
		if ( Style == 0 ) {
			DrawMemo( 0, 0 );
		}
	} else if ( ControlType == "TListBox" ) {
		//SkinImage->Width = tmemoPtr->Width;
		//SkinImage->Height = tmemoPtr->Height;
		//		ShowMessage("@");
		nscrollbar = new NScrollBar( myForm, tlistboxPtr );
		nscrollbar2 = new NScrollBar( myForm, tlistboxPtr );
		nscrollbar->setVertical() ;
		nscrollbar->init() ;
		nscrollbar2->setHorizontal() ;
		nscrollbar2->init() ;
		loadResourceImage();
		//el
		if ( Style == 0 ) {
			DrawListBox( 0, 0 );
		}
	} else if ( ControlType == "TTreeView" ) {
		//SkinImage->Width = tmemoPtr->Width;
		//SkinImage->Height = tmemoPtr->Height;
		//		ShowMessage("@");
		nscrollbar = new NScrollBar( myForm, ttreeviewPtr );
		nscrollbar2 = new NScrollBar( myForm, ttreeviewPtr );
		nscrollbar->setVertical() ;
		nscrollbar->init() ;
		nscrollbar2->setHorizontal() ;
		nscrollbar2->init() ;
		loadResourceImage();
		//el
		if ( Style == 0 ) {
			DrawTreeView( 0, 0 );
		}
	} else if ( ControlType == "TListView" ) {
		//SkinImage->Width = tmemoPtr->Width;
		//SkinImage->Height = tmemoPtr->Height;
		//		ShowMessage("@");
		nscrollbar = new NScrollBar( myForm, tlistviewPtr );
		nscrollbar2 = new NScrollBar( myForm, tlistviewPtr );
		nscrollbar->setVertical() ;
		nscrollbar->init() ;
		nscrollbar2->setHorizontal() ;
		nscrollbar2->init() ;
		loadResourceImage();
		//el
		if ( Style == 0 ) {
			DrawListView( 0, 0 );
		}
	} else if ( ControlType == "TCheckListBox" ) {
		//SkinImage->Width = tmemoPtr->Width;
		//SkinImage->Height = tmemoPtr->Height;
		//		ShowMessage("@");
		nscrollbar = new NScrollBar( myForm, tchecklistboxPtr );
		nscrollbar2 = new NScrollBar( myForm, tchecklistboxPtr );
		nscrollbar->setVertical() ;
		nscrollbar->init() ;
		nscrollbar2->setHorizontal() ;
		nscrollbar2->init() ;
		loadResourceImage();
		//el
		if ( Style == 0 ) {
			DrawCheckListBox( 0, 0 );
		}
	} else if ( ControlType == "TStringGrid" ) {
		//SkinImage->Width = tmemoPtr->Width;
		//SkinImage->Height = tmemoPtr->Height;
		//		ShowMessage("@");
		nscrollbar = new NScrollBar( myForm, tstringgridPtr );
		nscrollbar2 = new NScrollBar( myForm, tstringgridPtr );
		nscrollbar->setVertical() ;
		nscrollbar->init() ;
		nscrollbar2->setHorizontal() ;
		nscrollbar2->init() ;
		loadResourceImage();
		//el
		if ( Style == 0 ) {
			DrawStringGrid( 0, 0 );
		}
	} else if ( ControlType == "TDrawGrid" ) {
		//SkinImage->Width = tmemoPtr->Width;
		//SkinImage->Height = tmemoPtr->Height;
		//		ShowMessage("@");
		nscrollbar = new NScrollBar( myForm, tdrawgridPtr );
		nscrollbar2 = new NScrollBar( myForm, tdrawgridPtr );
		nscrollbar->setVertical() ;
		nscrollbar->init() ;
		nscrollbar2->setHorizontal() ;
		nscrollbar2->init() ;
		loadResourceImage();
		//el
		if ( Style == 0 ) {
			DrawDrawGrid( 0, 0 );
		}

	} else if ( ControlType == "TScrollBar" ) {
		//SkinImage->Width = tscrollbarPtr->Width;
		//SkinImage->Height = tscrollbarPtr->Height;
		//		ShowMessage("@");
		nscrollbar = new NScrollBar( myForm, tscrollbarPtr );
		if ( tscrollbarPtr->Kind == sbVertical )
			nscrollbar->setVertical() ;
		else
			nscrollbar->setHorizontal() ;
		nscrollbar->init() ;
		//		loadResourceImage();
		//el
		if ( Style == 0 ) {
			DrawScrollBar( 0, 0 );
		}
	} else if ( ControlType == "TPageControl" ) {
		SkinImage->Width = tpagecontrolPtr->Width;
		SkinImage->Height = tpagecontrolPtr->Height;
		loadResourceImage();
		for ( i = 0;i < tpagecontrolPtr->PageCount;i++ ) {
			if ( pageButton[ i ] == NULL ) {
				// ShowMessage("~~");
				pageButton[ i ] = new TBitBtn( myForm );
				//ShowMessage( pageButton[i]->Name );
				pageButton[ i ] ->Parent = myForm ;
				pageButton[ i ] ->Tag = i;
				pageButton[ i ] ->Caption = AnsiString( i );
				pageButton[ i ] ->OnMouseDown = pageButtonMouseDown ;
				pageButton[ i ] ->Visible = false;
			}
		}
		//el
		if ( Style == 0 ) {
			DrawPageControl( 0, 0 );
		}
	}

}
void __fastcall TControlSubClass::ReplaceWProc( Classes::TWndMethod &oldProc ) {
	//WindowProc
	orgWindowProc = oldProc;
	oldProc = ControlSubClass;
}
void __fastcall TControlSubClass::RestoreWProc( Classes::TWndMethod &newProc ) {
	//        if( orgWindowProc!=NULL )
	newProc = orgWindowProc;
}

