#include "SkinLib.h"
void __fastcall TControlSubClass::DrawPanel( int buttonState, int extra ) {
	int i, j, k;

	if ( !SkinImage )
		return ;
	if ( !tpanelPtr )
		return ;

	if ( strstr( tpanelPtr->Name.c_str() , "NScrollBarPanel" ) ) {

		HDC dc = GetDC( tpanelPtr->Handle );
		Graphics::TBitmap *tbmp = new Graphics::TBitmap;
		tbmp->Width = tpanelPtr->Width;
		tbmp->Height = tpanelPtr->Height ;
		tbmp->PixelFormat = pf24bit;

		myShare->MainGE->AlongsideDraw( tbmp->Canvas, myShare->MainGE->bmpArray[ 9 ], 0, 0, tbmp->Width , tbmp->Height );
		::BitBlt( dc , 0 , 0, tbmp->Width , tbmp->Height , tbmp->Canvas->Handle , 0, 0, SRCCOPY );
		::ReleaseDC( tpanelPtr->Handle , dc );
		delete tbmp;
		return ;
	} else if ( strstr( tpanelPtr->Name.c_str() , "NScrollBarMax" ) ) {

		HDC dc = GetDC( tpanelPtr->Handle );
		Graphics::TBitmap *tbmp = new Graphics::TBitmap;
		tbmp->Width = tpanelPtr->Width;
		tbmp->Height = tpanelPtr->Height ;
		tbmp->PixelFormat = pf24bit;
		if ( tpanelPtr->Tag == 0 ) {
			// Vertical
			if ( buttonState == 0 )
				myShare->MainGE->StretchDraw( tbmp->Canvas,
										myShare->MainGE->GetSubImage(3,0,
											myShare->MainGE->bmpArray[7]->Width/6,
											myShare->MainGE->bmpArray[7]->Height,
											myShare->MainGE->bmpArray[7],
											bmpBuffer),
											  0, 0, tbmp->Width , tbmp->Height );
			else if ( buttonState == 1 )
				myShare->MainGE->StretchDraw( tbmp->Canvas,
										myShare->MainGE->GetSubImage(4,0,
											myShare->MainGE->bmpArray[7]->Width/6,
											myShare->MainGE->bmpArray[7]->Height,
											myShare->MainGE->bmpArray[7],
											bmpBuffer),
											  0, 0, tbmp->Width , tbmp->Height );
			else if ( buttonState == 2 )
				myShare->MainGE->StretchDraw( tbmp->Canvas,
										myShare->MainGE->GetSubImage(5,0,
											myShare->MainGE->bmpArray[7]->Width/6,
											myShare->MainGE->bmpArray[7]->Height,
											myShare->MainGE->bmpArray[7],
											bmpBuffer),
											  0, 0, tbmp->Width , tbmp->Height );

		} else {
			// Horizontal
			if ( buttonState == 0 )
				myShare->MainGE->StretchDraw( tbmp->Canvas,
										myShare->MainGE->GetSubImage(3,0,
											myShare->MainGE->bmpArray[5]->Width/6,
											myShare->MainGE->bmpArray[5]->Height,
											myShare->MainGE->bmpArray[5],
											bmpBuffer),
											  0, 0, tbmp->Width , tbmp->Height );
			else if ( buttonState == 1 )
				myShare->MainGE->StretchDraw( tbmp->Canvas,
										myShare->MainGE->GetSubImage(4,0,
											myShare->MainGE->bmpArray[5]->Width/6,
											myShare->MainGE->bmpArray[5]->Height,
											myShare->MainGE->bmpArray[5],
											bmpBuffer),
											  0, 0, tbmp->Width , tbmp->Height );
			else if ( buttonState == 2 )
				myShare->MainGE->StretchDraw( tbmp->Canvas,
										myShare->MainGE->GetSubImage(5,0,
											myShare->MainGE->bmpArray[5]->Width/6,
											myShare->MainGE->bmpArray[5]->Height,
											myShare->MainGE->bmpArray[5],
											bmpBuffer),
											  0, 0, tbmp->Width , tbmp->Height );
		}
		::BitBlt( dc , 0 , 0, tbmp->Width , tbmp->Height , tbmp->Canvas->Handle , 0, 0, SRCCOPY );
		::ReleaseDC( tpanelPtr->Handle , dc );
		delete tbmp;
		return ;
	} else if ( strstr( tpanelPtr->Name.c_str() , "NScrollBarMin" ) ) {

		HDC dc = GetDC( tpanelPtr->Handle );
		Graphics::TBitmap *tbmp = new Graphics::TBitmap;
		tbmp->Width = tpanelPtr->Width;
		tbmp->Height = tpanelPtr->Height ;
		tbmp->PixelFormat = pf24bit;
		if ( tpanelPtr->Tag == 0 ) {
			// Vertical
			if ( buttonState == 0 )
				myShare->MainGE->StretchDraw( tbmp->Canvas,
										myShare->MainGE->GetSubImage(0,0,
											myShare->MainGE->bmpArray[7]->Width/6,
											myShare->MainGE->bmpArray[7]->Height,
											myShare->MainGE->bmpArray[7],
											bmpBuffer),
											  0, 0, tbmp->Width , tbmp->Height );
			else if ( buttonState == 1 )
				myShare->MainGE->StretchDraw( tbmp->Canvas,
										myShare->MainGE->GetSubImage(1,0,
											myShare->MainGE->bmpArray[7]->Width/6,
											myShare->MainGE->bmpArray[7]->Height,
											myShare->MainGE->bmpArray[7],
											bmpBuffer),
											  0, 0, tbmp->Width , tbmp->Height );
			else if ( buttonState == 2 )
				myShare->MainGE->StretchDraw( tbmp->Canvas,
										myShare->MainGE->GetSubImage(2,0,
											myShare->MainGE->bmpArray[7]->Width/6,
											myShare->MainGE->bmpArray[7]->Height,
											myShare->MainGE->bmpArray[7],
											bmpBuffer),
											  0, 0, tbmp->Width , tbmp->Height );

		} else {
			// Horizontal
			if ( buttonState == 0 )
				myShare->MainGE->StretchDraw( tbmp->Canvas,
										myShare->MainGE->GetSubImage(0,0,
											myShare->MainGE->bmpArray[5]->Width/6,
											myShare->MainGE->bmpArray[5]->Height,
											myShare->MainGE->bmpArray[5],
											bmpBuffer),
											  0, 0, tbmp->Width , tbmp->Height );
			else if ( buttonState == 1 )
				myShare->MainGE->StretchDraw( tbmp->Canvas,
										myShare->MainGE->GetSubImage(1,0,
											myShare->MainGE->bmpArray[5]->Width/6,
											myShare->MainGE->bmpArray[5]->Height,
											myShare->MainGE->bmpArray[5],
											bmpBuffer),
											  0, 0, tbmp->Width , tbmp->Height );
			else if ( buttonState == 2 )
				myShare->MainGE->StretchDraw( tbmp->Canvas,
										myShare->MainGE->GetSubImage(2,0,
											myShare->MainGE->bmpArray[5]->Width/6,
											myShare->MainGE->bmpArray[5]->Height,
											myShare->MainGE->bmpArray[5],
											bmpBuffer),
											  0, 0, tbmp->Width , tbmp->Height );
		}
		::BitBlt( dc , 0 , 0, tbmp->Width , tbmp->Height , tbmp->Canvas->Handle , 0, 0, SRCCOPY );
		::ReleaseDC( tpanelPtr->Handle , dc );
		delete tbmp;
		return ;
	} else if ( strstr( tpanelPtr->Name.c_str() , "NScrollBarThumb" ) ) {
		HDC dc = GetDC( tpanelPtr->Handle );
		Graphics::TBitmap *tbmp = new Graphics::TBitmap;
		tbmp->Width = tpanelPtr->Width;
		tbmp->Height = tpanelPtr->Height ;
		tbmp->PixelFormat = pf24bit;
		if ( tpanelPtr->Tag == 0 ) {
			// Vertical
			if ( buttonState == 0 ){
				myShare->MainGE->ScrollBarDrawH( tbmp->Canvas,
										myShare->MainGE->GetSubImage(2,0,
											myShare->MainGE->bmpArray[8]->Width/4,
											myShare->MainGE->bmpArray[8]->Height,
											myShare->MainGE->bmpArray[8],
											bmpBuffer),
											  0, 0, tbmp->Width , tbmp->Height );
				myShare->MainGE->StretchDraw( tbmp->Canvas,
										myShare->MainGE->GetSubImage(0,0,
											myShare->MainGE->bmpArray[8]->Width/4,
											myShare->MainGE->bmpArray[8]->Height,
											myShare->MainGE->bmpArray[8],
											bmpBuffer),
											  0, 0, tbmp->Width , myShare->MainGE->bmpArray[8]->Height );
				myShare->MainGE->StretchDraw( tbmp->Canvas,
										myShare->MainGE->GetSubImage(1,0,
											myShare->MainGE->bmpArray[8]->Width/4,
											myShare->MainGE->bmpArray[8]->Height,
											myShare->MainGE->bmpArray[8],
											bmpBuffer),
											  0, tbmp->Height-myShare->MainGE->bmpArray[8]->Height , tbmp->Width , myShare->MainGE->bmpArray[8]->Height );

			}else if ( buttonState == 1 ){
				myShare->MainGE->ScrollBarDrawH( tbmp->Canvas,
										myShare->MainGE->GetSubImage(2,0,
											myShare->MainGE->bmpArray[8]->Width/4,
											myShare->MainGE->bmpArray[8]->Height,
											myShare->MainGE->bmpArray[8],
											bmpBuffer),
											  0, 0, tbmp->Width , tbmp->Height );
				myShare->MainGE->StretchDraw( tbmp->Canvas,
										myShare->MainGE->GetSubImage(0,0,
											myShare->MainGE->bmpArray[8]->Width/4,
											myShare->MainGE->bmpArray[8]->Height,
											myShare->MainGE->bmpArray[8],
											bmpBuffer),
											  0, 0, tbmp->Width , myShare->MainGE->bmpArray[8]->Height );
				myShare->MainGE->StretchDraw( tbmp->Canvas,
										myShare->MainGE->GetSubImage(1,0,
											myShare->MainGE->bmpArray[8]->Width/4,
											myShare->MainGE->bmpArray[8]->Height,
											myShare->MainGE->bmpArray[8],
											bmpBuffer),
											  0, tbmp->Height-myShare->MainGE->bmpArray[8]->Height , tbmp->Width , myShare->MainGE->bmpArray[8]->Height );
			}else if ( buttonState == 2 ){
				myShare->MainGE->ScrollBarDrawV( tbmp->Canvas,
										myShare->MainGE->GetSubImage(2,0,
											myShare->MainGE->bmpArray[8]->Width/4,
											myShare->MainGE->bmpArray[8]->Height,
											myShare->MainGE->bmpArray[8],
											bmpBuffer),
											  0, 0, tbmp->Width , tbmp->Height );
				myShare->MainGE->StretchDraw( tbmp->Canvas,
										myShare->MainGE->GetSubImage(0,0,
											myShare->MainGE->bmpArray[8]->Width/4,
											myShare->MainGE->bmpArray[8]->Height,
											myShare->MainGE->bmpArray[8],
											bmpBuffer),
											  0, 0, tbmp->Width , myShare->MainGE->bmpArray[8]->Height );
				myShare->MainGE->StretchDraw( tbmp->Canvas,
										myShare->MainGE->GetSubImage(1,0,
											myShare->MainGE->bmpArray[8]->Width/4,
											myShare->MainGE->bmpArray[8]->Height,
											myShare->MainGE->bmpArray[8],
											bmpBuffer),
											  0, tbmp->Height-myShare->MainGE->bmpArray[8]->Height , tbmp->Width , myShare->MainGE->bmpArray[8]->Height );
			}

		} else {
			// Horizontal
			if ( buttonState == 0 ){
				myShare->MainGE->ScrollBarDrawH( tbmp->Canvas,
										myShare->MainGE->GetSubImage(0,2,
											myShare->MainGE->bmpArray[6]->Width,
											myShare->MainGE->bmpArray[6]->Height/4,
											myShare->MainGE->bmpArray[6],
											bmpBuffer),
											  0, 0, tbmp->Width , tbmp->Height );
				myShare->MainGE->StretchDraw( tbmp->Canvas,
										myShare->MainGE->GetSubImage(0,0,
											myShare->MainGE->bmpArray[6]->Width,
											myShare->MainGE->bmpArray[6]->Height/4,
											myShare->MainGE->bmpArray[6],
											bmpBuffer),
											  0, 0, myShare->MainGE->bmpArray[6]->Width,tbmp->Height  );
				myShare->MainGE->StretchDraw( tbmp->Canvas,
										myShare->MainGE->GetSubImage(0,1,
											myShare->MainGE->bmpArray[6]->Width,
											myShare->MainGE->bmpArray[6]->Height/4,
											myShare->MainGE->bmpArray[6],
											bmpBuffer),
											  tbmp->Width-myShare->MainGE->bmpArray[6]->Width,0 , myShare->MainGE->bmpArray[6]->Width ,tbmp->Height );

			}else if ( buttonState == 1 ){
				myShare->MainGE->ScrollBarDrawH( tbmp->Canvas,
										myShare->MainGE->GetSubImage(0,2,
											myShare->MainGE->bmpArray[6]->Width,
											myShare->MainGE->bmpArray[6]->Height/4,
											myShare->MainGE->bmpArray[6],
											bmpBuffer),
											  0, 0, tbmp->Width , tbmp->Height );
				myShare->MainGE->StretchDraw( tbmp->Canvas,
										myShare->MainGE->GetSubImage(0,0,
											myShare->MainGE->bmpArray[6]->Width,
											myShare->MainGE->bmpArray[6]->Height/4,
											myShare->MainGE->bmpArray[6],
											bmpBuffer),
											  0, 0, myShare->MainGE->bmpArray[6]->Width,tbmp->Height  );
				myShare->MainGE->StretchDraw( tbmp->Canvas,
										myShare->MainGE->GetSubImage(0,1,
											myShare->MainGE->bmpArray[6]->Width,
											myShare->MainGE->bmpArray[6]->Height/4,
											myShare->MainGE->bmpArray[6],
											bmpBuffer),
											  tbmp->Width-myShare->MainGE->bmpArray[6]->Width,0 , myShare->MainGE->bmpArray[6]->Width ,tbmp->Height );
			}else if ( buttonState == 2 ){
				myShare->MainGE->ScrollBarDrawH( tbmp->Canvas,
										myShare->MainGE->GetSubImage(0,2,
											myShare->MainGE->bmpArray[6]->Width,
											myShare->MainGE->bmpArray[6]->Height/4,
											myShare->MainGE->bmpArray[6],
											bmpBuffer),
											  0, 0, tbmp->Width , tbmp->Height );
				myShare->MainGE->StretchDraw( tbmp->Canvas,
										myShare->MainGE->GetSubImage(0,0,
											myShare->MainGE->bmpArray[6]->Width,
											myShare->MainGE->bmpArray[6]->Height/4,
											myShare->MainGE->bmpArray[6],
											bmpBuffer),
											  0, 0, myShare->MainGE->bmpArray[6]->Width,tbmp->Height  );
				myShare->MainGE->StretchDraw( tbmp->Canvas,
										myShare->MainGE->GetSubImage(0,1,
											myShare->MainGE->bmpArray[6]->Width,
											myShare->MainGE->bmpArray[6]->Height/4,
											myShare->MainGE->bmpArray[6],
											bmpBuffer),
											  tbmp->Width-myShare->MainGE->bmpArray[6]->Width,0 , myShare->MainGE->bmpArray[6]->Width ,tbmp->Height );

			}
		}
		::BitBlt( dc , 0 , 0, tbmp->Width , tbmp->Height , tbmp->Canvas->Handle , 0, 0, SRCCOPY );
		::ReleaseDC( tpanelPtr->Handle , dc );
		delete tbmp;
		return ;
	}
	if ( SkinImage->Height != tpanelPtr->Height )
		SkinImage->Height = tpanelPtr->Height;
	if ( SkinImage->Width != tpanelPtr->Width )
		SkinImage->Width = tpanelPtr->Width;


	RECT textArea;
	Graphics::TBitmap *localbkg = new Graphics::TBitmap();

//	localbkg->Width = tpanelPtr->Width ;
//	localbkg->Height = tpanelPtr->Height ;
//	localbkg->Canvas->CopyRect( Rect( 0, 0, tpanelPtr->Width , tpanelPtr->Height ), formBackground->Canvas, Rect( tpanelPtr->ClientOrigin.x - myForm->Left , tpanelPtr->ClientOrigin.y - myForm->Top , tpanelPtr->ClientOrigin.x - myForm->Left + tpanelPtr->Width , tpanelPtr->ClientOrigin.y - myForm->Top + tpanelPtr->Height ) );

	SkinImage->Canvas->Brush->Style = bsClear;
	SkinImage->Canvas->Draw(0,0,localbkg); 
	SkinImage->Canvas->Pen->Color = 0xcc9966; //RGB(220,225,255);
	SkinImage->Canvas->Pen->Style = psSolid;
//	SkinImage->Canvas->Pen->Width = 4;
	SkinImage->Canvas->RoundRect( 0, 0, tpanelPtr->Width , tpanelPtr->Height, 10, 10 );
//	skinAlpha( SkinImage , localbkg , 150 );
	textArea.left = ( tpanelPtr->Width - SkinImage->Canvas->TextWidth( tpanelPtr->Caption ) ) / 2 ;
	textArea.top = ( tpanelPtr->Height - SkinImage->Canvas->TextHeight( tpanelPtr->Caption ) ) / 2;
	textArea.right = textArea.left + SkinImage->Canvas->TextWidth( tpanelPtr->Caption );
	textArea.bottom = textArea.top + SkinImage->Canvas->TextHeight( tpanelPtr->Caption );
	DrawText( SkinImage->Canvas->Handle , tpanelPtr->Caption.c_str() , tpanelPtr->Caption.Length() , &textArea , DT_TABSTOP );

	HDC dc;
	dc = GetDC( tpanelPtr->Handle );
	// output Text
	BitBlt( dc , 0, 0, tpanelPtr->Width, tpanelPtr->Height, SkinImage->Canvas->Handle, 0, 0, SRCCOPY );
	ReleaseDC( tpanelPtr->Handle , dc );
	delete localbkg;

}

void __fastcall TControlSubClass::TPanelMsg( unsigned int Msg ) {
	//static bool mdown=false,mmove=false; //sA
	switch ( Msg ) {
		case WM_MOUSEMOVE:
			/*			if( mdown )
							DrawPanel(2,0);*/
			mmove = true;
			break;
		case WM_LBUTTONDOWN:
			DrawPanel( 2, 1 );
			mdown = true;
			break;
		case WM_LBUTTONUP:
			DrawPanel( 1, 0 );
			mdown = false;
			break;
		case WM_KEYDOWN:
			DrawPanel( 2, 1 );
			mdown = true;
			break;
		case WM_KEYUP:
			DrawPanel( 1, 1 );
			mdown = false;
			break;
		case CM_MOUSELEAVE:
			if ( mdown )
				DrawPanel( 2, 0 );
			else
				DrawPanel( 0, 0 );
			mmove = false;
			mdown = false;
			break;
		case WM_PAINT:
			//ݯSOBzA
			if ( mdown )
				DrawPanel( 2, 1 );
			else if ( mmove )
				DrawPanel( 1, 0 );
			else
				DrawPanel( 0, 0 );
			break;
		case CM_MOUSEENTER:
			DrawPanel( 1, 0 );
			mmove = true;
			break;
		case WM_LBUTTONDBLCLK:
			//			DrawPanel( 1, 1 );
			break;
		case WM_ERASEBKGND:
			DrawPanel( 0, 0 );
			break;
		case WM_NCPAINT:
			DrawPanel( 0, 0 );
			break;
		case WM_SETFOCUS:
			//ݭne@focus rect
			//			DrawPanel( 1, 1 );
			break;
		case WM_SIZING:
			break;
		case WM_MOVE:
			//DrawPanel( 0, 0 );
			break;
		default:
			//			DrawPanel( 0, 0 );
			break;
	}
}

