#include "skinlib.h"
void __fastcall TControlSubClass::DrawComboBox( int buttonState, int extra )
{
	int i, j, k;
	if ( !SkinImage )
		return ;
	if ( !tcomboboxPtr )
		return ;

	SkinImage->Width = 20;
	SkinImage->Height = tcomboboxPtr->Height ;	


	HDC dc;
	dc = GetDC( tcomboboxPtr->Handle );


	//BitBlt( dc, tcomboboxPtr->Width - 20, 0 , 20, tcomboboxPtr->Height, SkinImage->Canvas->Handle, 0, 0, SRCCOPY );
	if( buttonState==0 ){
		myShare->MainGE->StretchDraw( SkinImage->Canvas ,
			myShare->MainGE->GetSubImage(0,0,myShare->MainGE->bmpArray[4]->Width /3,myShare->MainGE->bmpArray[4]->Height ,myShare->MainGE->bmpArray[4],bmpBuffer) ,
			 0 , 0 , SkinImage->Width , SkinImage->Height );
	}else if( buttonState==1 ){
		myShare->MainGE->StretchDraw( SkinImage->Canvas ,
			myShare->MainGE->GetSubImage(1,0,myShare->MainGE->bmpArray[4]->Width /3,myShare->MainGE->bmpArray[4]->Height ,myShare->MainGE->bmpArray[4],bmpBuffer) ,
			 0 , 0 , SkinImage->Width , SkinImage->Height );
	}else if( buttonState==2 ){
		myShare->MainGE->StretchDraw( SkinImage->Canvas ,
			myShare->MainGE->GetSubImage(1,0,myShare->MainGE->bmpArray[4]->Width /3,myShare->MainGE->bmpArray[4]->Height ,myShare->MainGE->bmpArray[4],bmpBuffer) ,
			 0 , 0 , SkinImage->Width , SkinImage->Height );
	}
	BitBlt( dc, tcomboboxPtr->Width - 20, 0 , 20, tcomboboxPtr->Height, SkinImage->Canvas->Handle, 0, 0, SRCCOPY );

	ReleaseDC( tcomboboxPtr->Handle , dc );
	tcomboboxPtr->Canvas->Brush->Style = bsClear;
	if ( extra == 1 )
		tcomboboxPtr->Canvas->Pen->Color = RGB( 200, 232, 235 );
	else
		tcomboboxPtr->Canvas->Pen->Color = RGB( 248, 207, 124 );
	tcomboboxPtr->Canvas->Pen->Style = psSolid;
	tcomboboxPtr->Canvas->Pen->Width = 4;
	tcomboboxPtr->Canvas->RoundRect( 0, 0, tcomboboxPtr->Width , tcomboboxPtr->Height, 10, 10 );

}

void __fastcall TControlSubClass::TComboBoxMsg( unsigned int Msg ) {
	//static bool mdown=false,mmove=false; //sA
	switch ( Msg ) {
		case WM_MOUSEMOVE:
			//DrawComboBox(1,0);
			mmove = true;
			break;
		case WM_LBUTTONDOWN:
			DrawComboBox( 2, 0 );
			mdown = true;
			break;
		case WM_LBUTTONUP:
			DrawComboBox( 1, 0 );
			mdown = false;
			break;
		case WM_KEYDOWN:
			DrawComboBox( 2, 0 );
			mdown = true;
			break;
		case WM_KEYUP:
			DrawComboBox( 1, 0 );
			mdown = false;
			break;
		case CM_MOUSELEAVE:
			DrawComboBox( 0, 0 );
			mmove = false;
			mdown = false;
			break;
		case WM_PAINT:
			//ݯSOBzA
			if ( mdown )
				DrawComboBox( 2, 0 );
			else if ( mmove )
				DrawComboBox( 1, 1 );
			else
				DrawComboBox( 0, 0 );
			break;
		case CM_MOUSEENTER:
			DrawComboBox( 1, 1 );
			mmove = true;
			break;
		case WM_LBUTTONDBLCLK:
			DrawComboBox( 1, 0 );
			break;
		case WM_ERASEBKGND:
			DrawComboBox( 0, 0 );
			break;
		case WM_NCPAINT:
			DrawComboBox( 0, 0 );
			break;
		case WM_SETFOCUS:
			//ݭne@focus rect
			getfocus = true;
			DrawComboBox( 1, 0 );
			break;
		case WM_KILLFOCUS:
			getfocus = false;
			DrawComboBox( 0, 0 );
			break;
		default:
			DrawComboBox( 0, 0 );
			break;
	}
}

