#ifndef _NGlobal
#define _NGlobal
#include "skinlib.h"
inline void skinAlpha( Graphics::TBitmap *bkg , Graphics::TBitmap *foreg , int alpha ) {
	register Byte * p, *q;
	register int i, j;
	register int x2;
	register int minHeight = myMin( bkg->Height , foreg->Height ), minWidth = myMin( bkg->Width , foreg->Width );
	bkg->PixelFormat = pf24bit;
	foreg->PixelFormat = pf24bit;
	for ( i = 0;i < minHeight ;++i ) {

		p = ( Byte* ) bkg->ScanLine[ i ];
		q = ( Byte* ) foreg->ScanLine[ i ];
		for ( j = 0;j < minWidth ;++j ) {
			x2 = ( j << 1 ) + j;
			//			p[ x2 ] = ( Byte ) (  (q[ x2 ] * alpha) >>8 ) + (( p[ x2 ] * ( 255-alpha )) >>8);
			//                        p[ x2+1 ] = ( Byte ) (  (q[ x2+1 ] * alpha) >>8 ) + (( p[ x2+1 ] * ( 255-alpha )) >>8);
			//                        p[ x2+2 ] = ( Byte ) (  (q[ x2+2 ] * alpha) >>8 ) + (( p[ x2+2 ] * ( 255-alpha )) >>8);
			p[ x2 ] += ( ( ( q[ x2 ] - p[ x2 ] ) * alpha ) >> 8 ); //(  (q[ x2 ]  >>1 ) + (( p[ x2 ] * ( 255-alpha )) >>8);
			p[ x2 + 1 ] += ( ( ( q[ x2 + 1 ] - p[ x2 + 1 ] ) * alpha ) >> 8 ) ; //(  (q[ x2+1 ] >>1 ) + (( p[ x2+1 ] * ( 255-alpha )) >>8);
			p[ x2 + 2 ] += ( ( ( q[ x2 + 2 ] - p[ x2 + 2 ] ) * alpha ) >> 8 ); //(  (q[ x2+2 ] >>1 ) + (( p[ x2+2 ] * ( 255-alpha )) >>8);
		}
	}

}
inline void skinBrightness( Graphics::TBitmap *Bmp, int posi ) {
	//        Graphics::
	Bmp->PixelFormat = pf24bit;
	Byte* ptr = NULL;
	for ( int y = 0;y < Bmp->Height ;y++ ) {
		ptr = ( Byte* ) Bmp->ScanLine[ y ];
		for ( int x = 0;x < Bmp->Width ;x++ ) {
			int R = ptr[ x * 3 + 2 ];
			int G = ptr[ x * 3 + 1 ];
			int B = ptr[ x * 3 ];
			int RValue = R + posi;
			int GValue = G + posi + 5;
			int BValue = B + posi + 10;

			if ( RValue > 255 )
				ptr[ x * 3 + 2 ] = 255;
			else if ( RValue < 0 )
				ptr[ x * 3 + 2 ] = 0;
			else
				ptr[ x * 3 + 2 ] = RValue;

			if ( GValue > 255 )
				ptr[ x * 3 + 1 ] = 255;
			else if ( GValue < 0 )
				ptr[ x * 3 + 1 ] = 0;
			else
				ptr[ x * 3 + 1 ] = GValue;

			if ( BValue > 255 )
				ptr[ x * 3 ] = 255;
			else if ( BValue < 0 )
				ptr[ x * 3 ] = 0;
			else
				ptr[ x * 3 ] = BValue;
		}
	}

	//	Brig_Bmp = Bmp;
}

inline void RGBAClear( Graphics::TBitmap *Bmp ) {
	//        Graphics::
	Bmp->PixelFormat = pf32bit;
	Byte* ptr = NULL;
	int R, G, B, A;
	int myWidth = Bmp->Width , myHeight = Bmp->Height ;
	for ( int y = 0;y < myHeight ;y++ ) {
		ptr = ( Byte* ) Bmp->ScanLine[ y ];
		for ( int x = 0;x < myWidth ;x++ ) {
			ptr[ x * 4 + 3 ] = 0;
			ptr[ x * 4 + 2 ] = 0;
			ptr[ x * 4 + 1 ] = 0 ;
			ptr[ x * 4 ] = 0 ;
		}
	}
}



#endif
