#include "SkinLib.h"
void __fastcall TControlSubClass::DrawRadioGroup( int buttonState, int extra ) {
	int i, j, k;
	if ( !SkinImage )
		return ;
	if ( !tradiogroupPtr )
		return ;
	if ( SkinImage->Height != tradiogroupPtr->Height )
		SkinImage->Height = tradiogroupPtr->Height;
	if ( SkinImage->Width != tradiogroupPtr->Width )
		SkinImage->Width = tradiogroupPtr->Width;


	RECT textArea;
	Graphics::TBitmap *localbkg = new Graphics::TBitmap();

	localbkg->Width = tradiogroupPtr->Width ;
	localbkg->Height = tradiogroupPtr->Height ;

	SkinImage->Canvas->Brush->Style = bsClear;
	SkinImage->Canvas->Draw(0,0,localbkg);
	SkinImage->Canvas->Pen->Color = 0xcc9966; //RGB(220,225,255);
	SkinImage->Canvas->Pen->Style = psSolid;

	SkinImage->Canvas->RoundRect( 0, 0, tradiogroupPtr->Width , tradiogroupPtr->Height, 10, 10 );
	textArea.left = ( tradiogroupPtr->Width - SkinImage->Canvas->TextWidth( tradiogroupPtr->Caption ) ) / 2 ;
	textArea.top = ( tradiogroupPtr->Height - SkinImage->Canvas->TextHeight( tradiogroupPtr->Caption ) ) / 2;
	textArea.right = textArea.left + SkinImage->Canvas->TextWidth( tradiogroupPtr->Caption );
	textArea.bottom = textArea.top + SkinImage->Canvas->TextHeight( tradiogroupPtr->Caption );
	DrawText( SkinImage->Canvas->Handle , tradiogroupPtr->Caption.c_str() , tradiogroupPtr->Caption.Length() , &textArea , DT_TABSTOP );

	HDC dc;
	dc = GetDC( tradiogroupPtr->Handle );
	// output Text
	BitBlt( dc , 0, 0, tradiogroupPtr->Width, tradiogroupPtr->Height, SkinImage->Canvas->Handle, 0, 0, SRCCOPY );
	ReleaseDC( tradiogroupPtr->Handle , dc );
	delete localbkg;

}

void __fastcall TControlSubClass::TRadioGroupMsg( unsigned int Msg ) {
	//static bool mdown=false,mmove=false; //sA
	switch ( Msg ) {
		case WM_MOUSEMOVE:

			mmove = true;
			break;
		case WM_LBUTTONDOWN:
			DrawRadioGroup( 2, 1 );
			mdown = true;
			break;
		case WM_LBUTTONUP:
			DrawRadioGroup( 1, 0 );
			mdown = false;
			break;
		case WM_KEYDOWN:
			DrawRadioGroup( 2, 1 );
			mdown = true;
			break;
		case WM_KEYUP:
			DrawRadioGroup( 1, 1 );
			mdown = false;
			break;
		case CM_MOUSELEAVE:
			if ( mdown )
				DrawRadioGroup( 2, 0 );
			else
				DrawRadioGroup( 0, 0 );
			mmove = false;
			mdown = false;
			break;
		case WM_PAINT:
			//ݯSOBzA
			if ( mdown )
				DrawRadioGroup( 2, 1 );
			else if ( mmove )
				DrawRadioGroup( 1, 0 );
			else
				DrawRadioGroup( 0, 0 );
			break;
		case CM_MOUSEENTER:
			DrawRadioGroup( 1, 0 );
			mmove = true;
			break;
		case WM_LBUTTONDBLCLK:
			//			DrawRadioGroup( 1, 1 );
			break;
		case WM_ERASEBKGND:
			DrawRadioGroup( 0, 0 );
			break;
		case WM_NCPAINT:
			//			DrawRadioGroup( 0, 0 );
			break;
		case WM_SETFOCUS:
			//ݭne@focus rect
			//			DrawRadioGroup( 1, 1 );
			break;
		case WM_NCLBUTTONUP:
			break;
		default:
			//			DrawRadioGroup( 0, 0 );
			break;
	}
}

