#include "SkinLib.h"
void __fastcall TControlSubClass::DrawScrollBar( int buttonState, int extra ) {
	int i, j, k;
	if ( !SkinImage )
		return ;
	if ( !tscrollbarPtr )
		return ;
	//ϥNScrollBarӴN
	if ( nscrollbar->Left != tscrollbarPtr->Left )
		nscrollbar->Left = tscrollbarPtr->Left ;

	if ( nscrollbar->Top != tscrollbarPtr->Top )
		nscrollbar->Top = tscrollbarPtr->Top ;
	if ( nscrollbar->Width != tscrollbarPtr->Width )
		nscrollbar->Width = tscrollbarPtr->Width ;
	if ( nscrollbar->Height != tscrollbarPtr->Height )
		nscrollbar->Height = tscrollbarPtr->Height ;

	nscrollbar->Min = tscrollbarPtr->Min ;
	nscrollbar->Max = tscrollbarPtr->Max ;
	nscrollbar->Position = tscrollbarPtr->Position ;
	nscrollbar->Refresh() ;

}


void __fastcall TControlSubClass::TScrollBarMsg( unsigned int Msg ) {
	//static bool mdown=false,mmove=false; //sA
	switch ( Msg ) {
		case WM_MOUSEMOVE:
			//DrawScrollBar(1,0);
			mmove = true;
			break;
		case WM_LBUTTONDOWN:
			DrawScrollBar( 2, 1 );
			mdown = true;
			break;
		case WM_LBUTTONUP:
			DrawScrollBar( 1, 0 );
			mdown = false;
			break;
		case WM_KEYDOWN:
			DrawScrollBar( 2, 1 );
			mdown = true;
			break;
		case WM_KEYUP:
			DrawScrollBar( 1, 1 );
			mdown = false;
			break;
		case CM_MOUSELEAVE:
			DrawScrollBar( 0, 0 );
			mmove = false;
			mdown = false;
			break;
		case WM_PAINT:
			//ݯSOBzA
			if ( mdown )
				DrawScrollBar( 2, 1 );
			else if ( mmove )
				DrawScrollBar( 1, 0 );
			else
				DrawScrollBar( 0, 0 );
			break;
		case CM_MOUSEENTER:
			DrawScrollBar( 1, 0 );
			mmove = true;
			break;
		case WM_LBUTTONDBLCLK:
			DrawScrollBar( 1, 1 );
			break;
		case WM_ERASEBKGND:
			DrawScrollBar( 0, 0 );
			break;
		case WM_NCPAINT:
			DrawScrollBar( 0, 0 );
			break;
		case WM_SETFOCUS:
			//ݭne@focus rect
			DrawScrollBar( 1, 1 );
			break;
		default:
			DrawScrollBar( 0, 0 );
			break;
	}
}

